<?php

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once( "includes/HTML_toolbar.php" );


class HTML_jbd {

  /**
   * Function to write the footer
   */
  function _footer($colspan=1) {
     echo '<!-- Footer & Copyrights -->'."\n";
     if (mosjbdTools::getPref(-1,'params','displaycopyrights', '1')) {
        echo '  <tr align="center"><td class="small" colspan="'.$colspan.'">' .mosjbd::getVersion(). '<b> <a href="http://www.ivo.unwe.net/" target="_blank">&copy; 2005 Ivo Apostolov</a></b></td></tr>'."\n";
     }
  }




  function ShowCatsHoriz ($option, $catid, &$categories, $Itemid, &$params) {
    global $mosConfig_live_site;

    $nbcols = intval( $params->catnbcolumns );

    $ii = 0;
    $col = 0;

    if ($categories) {    // Something to display ???

       $items = 0;

       foreach ($categories as $cat) {
         if ($cat->parent == $categories[0]->parent) {
            $items++;
         }  // Counts only cats of the 1st level
       }
       $nbrows = ceil($items / $nbcols);

       $catlevel = 0;
       $line=0;
       $catitem = 0;
       $item = 0;
       $subcats = 0;

       // *** Loading Bots if requested
       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?
          global $_MAMBOTS;
          $_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
       }

       if ( $items > 0 ) {    // Some cats to display

          echo '  <tr><td>'."\n";
          echo '    <table class="contentpane" border="0" cellspacing="0" cellpadding="' .$params->paddingcategories. '" width="100%">'."\n";

          while ( $line < $nbrows ) {
              $col=0;
              echo '      <tr>'."\n";    // new line

              while ( $col < $nbcols ) {

                 if ( $item < $items ) {     // This is a cell with a content

                    $jj = 0;
                    for ($ii=0; $ii < count($categories); $ii++) {  // determine Cat for the grid position
                       if ($categories[$ii]->parent == $categories[0]->parent ) { // Count only cats of the 1st level
                          if ($jj == $item) {
                             $catitem = $ii;
                             break;
                          }
                          $jj++;
                       }
                    }

                    $cat = $categories[$catitem];

                    echo '        <td width="' .floor(100/$nbcols). '%" valign="top">';    //   New Cell    nowrap="nowrap"

                    if ( $cat->numlinks != 0 || $cat->numchild != 0 ) {
                       echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$cat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosjbdTools::cssClass($params->csscategories).' title="' .htmlspecialchars($cat->name, ENT_NOQUOTES);
                       if ($params->catshowcount) {
                          echo '&nbsp;(';
                          echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks." "._BMU_jbd : "";
                          echo ($params->catshowcount == 1) ? ' + ' : "";
                          echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild." "._BMU_SUBCATEGORIES : "";
                          echo ')';
                       }
                       echo '">';
                    }

                    if ($params->catlistmode && $cat->icon) {
                       $iconurl = $mosConfig_live_site. '/images/stories/' .$cat->icon;
                       echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                    } else {
                       echo mosjbdTools::imageArrow();
                    }

                    echo htmlspecialchars($cat->title, ENT_NOQUOTES);

                    if ( $cat->numlinks != 0 || $cat->numchild != 0 ) {
                         echo '</a>';
                    }

                    if ($params->catshowcount) {
                       echo '&nbsp;<span class="small">(';
                       echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks : "";
                       echo ($params->catshowcount == 1) ? '+' : "";
                       echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild : "";
                       echo ')</span>';
                    }

                    // *** Display Category Description
                    if ($params->showcatlistdesc && $cat->description) {
                       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                          $row->text = $cat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                          $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                          $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                          $page = 0;                         // MosBot pagination system
                          $prms = "";
                          $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                          echo '<!-- Bots -->'."\n";
                          // Process the MosBots
                          $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                          // Update field with processed text
                          $cat->description = $row->text;
                       }
                       echo "<br />\n" . $cat->description;
                    }

                    $catitem++;
                    if ( ($cat->numchild > 0) && ($params->subcatsdisplay > 0)) {  // Need to display Sub-Cats

                       $subcats = 0;
                       echo "<br />\n";

                       while ( ($subcats < $params->subcatsdisplay) && ($subcats < $cat->numchild) && ($categories[$catitem]->parent != $categories[0]->parent) ) {     // it's a Subcat
                            $scat = $categories[$catitem];    // Get Cat
                            if ($params->subcatsorder) {
                               echo ($subcats) ? ",&nbsp;\n" : "\n";
                            } else {
                               echo ($subcats) ? "<br />\n" : "\n";
                            }

                            if ($params->catlistmode==2 && $scat->icon) {
                               $iconurl = $mosConfig_live_site. '/images/stories/' .$scat->icon;
                               echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                            } else {
//                               echo mosjbdTools::imageArrow();
                            }

                            if ( ($scat->numlinks + $scat->numchild) == 0) {
                                 echo ''.htmlspecialchars($scat->title, ENT_NOQUOTES).'';
                            } else {
                                 echo '          <a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$scat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosjbdTools::cssClass($params->csssubcategories).' title="' .htmlspecialchars($scat->name, ENT_NOQUOTES);
                                 if ($params->catshowcount) {
                                    echo '&nbsp;(';
                                    echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $scat->numlinks." "._BMU_jbd : "";
                                    echo ($params->catshowcount == 1) ? '+' : "";
                                    echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $scat->numchild." "._BMU_SUBCATEGORIES : "";
                                    echo ')';
                                 }
                                 echo '">' .htmlspecialchars($scat->title, ENT_NOQUOTES). '</a>';
                            }
                            if ($params->catshowcount) {
                               echo '&nbsp;<span class="small">(';
                               echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $scat->numlinks : "";
                               echo ($params->catshowcount == 1) ? '+' : "";
                               echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $scat->numchild : "";
                               echo ')</span>';
                            }

                            // *** Display Sub-Category Description
                            if ($params->showcatlistdesc && $scat->description) {
                               if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                                  $row->text = $scat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                                  $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                                  $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                                  $page = 0;                         // MosBot pagination system
                                  $prms = "";
                                  $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                                  echo '<!-- Bots -->'."\n";
                                  // Process the MosBots
                                  $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                                  // Update field with processed text
                                  $scat->description = $row->text;
                               }
                               if (!$params->subcatsorder) {
                                  echo "<br />\n"; // vertical display
                               }
                               echo $scat->description;
                            }

                            $subcats++;
                            $catitem++;
                       }
                       if ( $cat->numchild > $params->subcatsdisplay ) {
                          echo ", ...";
                       }

                    }

                    echo '</td>'."\n";    // close cell
                 }
                 $col++;
                 $item++;
              }
              $line++;
              echo "      </tr>"."\n";
          }
          echo "    </table>"."\n";
          echo "  </td></tr>"."\n";
       }
    }
  }


  function ShowCatsVert ($option, $catid, &$categories, $Itemid, &$params) {
    global $mosConfig_live_site;

    $nbcols = intval( $params->catnbcolumns );

    $ii = 0;
    $col = 0;

    if ($categories) {    // Something to display ???

       $items = 0;

       foreach ($categories as $cat) {
         if ($cat->parent == $categories[0]->parent) {
            $items++;
         }  // Counts only cats of the 1st level
       }
       $nbrows = ceil($items / $nbcols);

       $catlevel = 0;
       $line=0;
       $catitem = 0;
       $item = 0;
       $subcats = 0;

       // *** Loading Bots if requested
       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?
          global $_MAMBOTS;
          $_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
       }

       if ( $items > 0 ) {    // Some cats to display

          echo '  <tr><td>'."\n";
          echo '    <table class="contentpane" border="0" cellspacing="0" cellpadding="' .$params->paddingcategories. '" width="100%">'."\n";

          while ( $line < $nbrows ) {
              $col=0;
              echo '      <tr>'."\n";    // new line

              while ( $col < $nbcols ) {

                 $item = ($col*$nbrows) + $line;  // compute grid position

                 if ( $item < $items ) {     // This is a cell with a content
                    $jj = 0;
                    for ($ii=0; $ii < count($categories); $ii++) {  // determine Cat for the grid position
                       if ($categories[$ii]->parent == $categories[0]->parent ) { // Count only cats of the 1st level
                          if ($jj == $item) {
                             $catitem = $ii;
                             break;
                          }
                          $jj++;
                       }
                    }
                    $cat = $categories[$catitem];

                    echo '        <td width="' .floor(100/$nbcols). '%" valign="top">';    //   New Cell    nowrap="nowrap"

//  echo "[l:$cat->numlinks|c:$cat->numchild|e:$params->showemptycats|s:$params->catshowcount]"; // Debug

                    if ( $params->showemptycats || (!$params->showemptycats && ($cat->numlinks != 0 || $cat->numchild != 0)) ) {
                       echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$cat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosjbdTools::cssClass($params->csscategories).' title="' .htmlspecialchars($cat->name, ENT_NOQUOTES);
                       if ($params->catshowcount) {
                          echo '&nbsp;(';
                          echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks." "._BMU_jbd : "";
                          echo ($params->catshowcount == 1) ? ' + ' : "";
                          echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild." "._BMU_SUBCATEGORIES : "";
                          echo ')';
                       }
                       echo '">';

                       if ($params->catlistmode && $cat->icon) {
                          $iconurl = $mosConfig_live_site. '/images/stories/' .$cat->icon;
                          echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                       } else {
                          echo mosjbdTools::imageArrow();
                       }

                       echo htmlspecialchars($cat->title, ENT_NOQUOTES);

                       echo '</a>';
                    }

                    if ($params->catshowcount) {
                       echo '&nbsp;<span class="small">(';
                       echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks : "";
                       echo ($params->catshowcount == 1) ? '+' : "";
                       echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild : "";
                       echo ')</span>';
                    }

                    // *** Display Category Description
                    if ($params->showcatlistdesc && $cat->description) {
                       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                          $row->text = $cat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                          $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                          $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                          $page = 0;                         // MosBot pagination system
                          $prms = "";
                          $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                          echo '<!-- Bots -->'."\n";
                          // Process the MosBots
                          $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                          // Update field with processed text
                          $cat->description = $row->text;
                       }
                       echo "<br />\n" . $cat->description;
                    }

                    if ( ($cat->numchild > 0) && ($params->subcatsdisplay > 0)) {  // Need to display Sub-cats

                       $subcats = 0;
                       echo "<br />\n";

                       $catitem++;
                       while ( ($subcats < $params->subcatsdisplay) && ($subcats < $cat->numchild) && ($categories[$catitem]->parent != $categories[0]->parent) ) {     // it's a Subcat
                            $scat = $categories[$catitem];    // Get Cat
                            if ($params->subcatsorder) {
                               echo ($subcats) ? ",&nbsp;\n" : "";
                            } else {
                               echo ($subcats) ? "<br />\n" : "";
                            }

                            if ($params->catlistmode==2 && $scat->icon) {
                               $iconurl = $mosConfig_live_site. '/images/stories/' .$scat->icon;
                               echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                            } else {
//                               echo mosjbdTools::imageArrow();
                            }

                            if ( (!$params->showemptycats) && (($scat->numlinks + $scat->numchild) == 0 ) ) {
                                 echo ''.htmlspecialchars($scat->title, ENT_NOQUOTES).'';
                            } else {
                                 echo '          <a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$scat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosjbdTools::cssClass($params->csssubcategories).' title="' .htmlspecialchars($scat->name, ENT_NOQUOTES);
                                 if ($params->catshowcount) {
                                    echo '&nbsp;(';
                                    echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $scat->numlinks." "._BMU_jbd : "";
                                    echo ($params->catshowcount == 1) ? ' + ' : "";
                                    echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $scat->numchild." "._BMU_SUBCATEGORIES : "";
                                    echo ')';
                                 }
                                 echo '">' .htmlspecialchars($scat->title, ENT_NOQUOTES). '</a>';
                            }
                            if ($params->catshowcount) {
                               echo '&nbsp;<span class="small">(';
                               echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $scat->numlinks : "";
                               echo ($params->catshowcount == 1) ? '+' : "";
                               echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $scat->numchild : "";
                               echo ')</span>';
                            }
                            // *** Display Sub-Category Description
                            if ($params->showcatlistdesc && $scat->description) {
                               if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                                  $row->text = $scat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                                  $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                                  $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                                  $page = 0;                         // MosBot pagination system
                                  $prms = "";
                                  $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                                  echo '<!-- Bots -->'."\n";
                                  // Process the MosBots
                                  $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                                  // Update field with processed text
                                  $scat->description = $row->text;
                               }
                               echo "<br />\n" . $scat->description;
                            }

                            $subcats++;
                            $catitem++;
                       }
                       if ( $cat->numchild > $params->subcatsdisplay ) {
                          echo ", ...";
                       }

                    }

                    echo '</td>'."\n";    // close cell
                    $col++;

                 } else {
                    $col++;
                 }
              }
              $line++;
              echo "      </tr>"."\n";
          }

          echo "    </table>"."\n";
          echo "  </td></tr>"."\n";

       }


    }
  }


  function ShowCatsTree($option, $catid, &$categories, $Itemid, &$params) {
    global $mosConfig_live_site, $mainframe;

    $nbcols = intval( $params->catnbcolumns );

    $ii = 0;
    $col = 0;

    if ($categories) {    // Something to display ???

       echo '  <tr><td>'."\n";
       echo '    <table class="contentpane" border="0" cellspacing="0" cellpadding="' .$params->paddingcategories. '" width="100%">'."\n";

       $item = 0;
       $items = sizeof($categories);
       $nbrows = ceil($items / $nbcols);

       $catlevel = 0;

       // *** Loading Bots if requested
       if ($params->botsoncatlistdesc ) {  // Need to process Bots ?
          global $_MAMBOTS;
          $_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
       }

       for ($line=0; $line < $nbrows; $line++) {
           echo "      <tr>\n";
           for ($col=0; $col < $nbcols; $col++) {
               echo '        <td width="' .floor(100/$nbcols). '%" valign="top">';    //   nowrap="nowrap"
               $item = ($col*$nbrows) + $line;
               if ( $item < $items ) {

                  $cat = $categories[$item];

                  if ($cat->catid > 0) {
                     $catlevel = 1;
                     $p = 0;
                     $p = strpos($cat->name,"/",$p);
                     while ($p > 0) {
                        $p = strpos($cat->name,"/", $p+1);
                        $catlevel++;
                     }
                  }

                  echo '<div>';

                  if ($catid == $cat->catid) { echo '<span'.mosjbdTools::cssClass($params->csscategoriessel).'>['; }

                    if ( $cat->numlinks != 0 || $cat->numchild != 0 ) {
                       echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=".$cat->catid."&navstart=".$params->navstart."&search=".$params->search). '"'.mosjbdTools::cssClass($params->csscategories).' title="' .htmlspecialchars($cat->name, ENT_NOQUOTES);
                       if ($params->catshowcount) {
                          echo '&nbsp;(';
                          echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks." "._BMU_jbd : "";
                          echo ($params->catshowcount == 1) ? ' + ' : "";
                          echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild." "._BMU_SUBCATEGORIES : "";
                          echo ')';
                       }
                       echo '">';
                    }

                    if ( ( ($catlevel <= 2 && $params->catlistmode==1) || ($params->catlistmode==2) ) && $cat->icon) {
                       $iconurl = $mosConfig_live_site. '/images/stories/' .$cat->icon;
                       echo '<img src="' .$iconurl. '" border="0" />&nbsp;';
                    } else {
                       for ($l=0; $l < $catlevel-1; $l++) { echo mosjbdTools::imageArrow(); } // Using default template bullet (list), instead of fixed image...
                    }

                    echo htmlspecialchars($cat->title, ENT_NOQUOTES);

                    if ( $cat->numlinks != 0 || $cat->numchild != 0 ) {
                         echo '</a>';
                    }

                  if ($params->catshowcount) {
                     echo '&nbsp;<span class="small">(';
                     echo ($params->catshowcount == 1 || $params->catshowcount == 2) ? $cat->numlinks : "";
                     echo ($params->catshowcount == 1) ? '+' : "";
                     echo ($params->catshowcount == 1 || $params->catshowcount == 3) ? $cat->numchild : "";
                     echo ')</span>';
                  }

                  if ($catid == $cat->catid) { echo "]</span>"; }

                  echo '</div>';

                  // *** Display Category Description
                  if ($params->showcatlistdesc && $cat->description) {
                     if ($params->botsoncatlistdesc ) {  // Need to process Bots ?

                        $row->text = $cat->description;    // MosBot only uses field "text" => Need to copy "detail" content ...
                        $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
                        $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                        $page = 0;                         // MosBot pagination system
                        $prms = "";
                        $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

                        echo '<!-- Bots -->'."\n";
                        // Process the MosBots
                        $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

                        // Update field with processed text
                        $cat->description = $row->text;
                     }
                     echo $cat->description;
                  }
               }
               echo "</td>\n";
           }
           echo "      </tr>\n";
       }

       echo "    </table>\n";
       echo "  </td></tr>\n";

    }
  }



  function alphaV ($val) {
    global $alphaIndex;
    // $val => *=-1 ]=0 / A=1 .. Z=26 / [=27
    $c = 0;

    if ($val > count($alphaIndex)-1 ) { $val = count($alphaIndex)-1; }       // protection for too high index

    switch ($val) {
      case -1 :     // All
          $c = "*"; break;
      default :
          $c =  ($alphaIndex[$val]);
    }

    return $c;
  }


  function alphaTest ($val) {
    global $alphaIndex;
    // $val => *=-1 ]=A / A=B .. Z=] / [=chr(255)
    $c = 0;
    if ($val >= count($alphaIndex) ) { $val = count($alphaIndex)-1; }       // protection for too high index

    switch ($val) {
      case count($alphaIndex)-1 :    // More than Z => Special chars
          $c = chr(255);  break;
      default :       // Chars
          $c =  ($alphaIndex[$val+1]);
    }

    return $c;
  }


  function ShowAlphaIndex ($option, $Itemid, $catid, &$params) {
    global $alphaIndex;
    global $mosConfig_live_site;

    $mode = $params->mode;
    echo '<tr align="center"><td'.mosjbdTools::cssClass($params->cssalphaindex).'>'."\n";
    $params->search = rawurldecode($params->search);   // Convert special chars to normal chars... => fix issue with ]=%5d and [=%5b
    if ($params->showsearchbox) {
//       echo '<form action="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=0"). '" method="post">'."\n";  // <== SEF conversion on Form submission makes some conflicts...
       echo '<form action="index.php?option=' .$option. '&Itemid=' .$Itemid. '&mode=' .$mode. '&catid=' .$catid. '&navstart=0" method="post">'."\n";
       echo '<input class="inputbox" type="text" name="search" value="'.$params->search.'" size="'.$params->searchboxsize.'" />&nbsp;'."\n";
    }
    if ($params->showalphaindex) {
      if ($params->search == "*") { echo '<span'.mosjbdTools::cssClass($params->cssalphaindexsel).'>['; }
      echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=0&search=*"). '" ><b>' ._BMU_ALL_jbd. '</b></a>';
      if ($params->search == "*") { echo ']</span>'; }
      for ($ii=0; $ii <= count($alphaIndex)-1; $ii++) {
          $s = HTML_jbd::alphaV($ii);
          if ($params->alphaindexsep1 == "S") {
             echo "&nbsp;";
          } elseif ($params->alphaindexsep1 != "N") {
             echo $params->alphaindexsep1;
          }
          if (strtoupper($params->search) == $s) { echo '<span'.mosjbdTools::cssClass($params->cssalphaindexsel).'>['; }
             echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=0&search=".strtolower($s) ). '"><b>'.$s.'</b></a>';
          if (strtoupper($params->search) == $s) { echo ']</span>'; }
      }
      echo "\n";
      if ($params->showsearchbox) {
         echo '</form>'."\n";
      }
    }
    echo '</td></tr>'."\n";

  }


  function BackToIndexAlpha ($option, $Itemid, $catid, &$params, $alpha, &$blocks, $last=false) {
    global $mosConfig_live_site;

    $mode = $params->mode;
    echo '<tr align="left"><td>'."\n";

    echo '   <table border="0" cellspacing="0" cellpadding="0" width="100%">'."\n";
    echo '    <tr>'."\n";

    if (!$last) {
       echo '     <td '.mosjbdTools::cssClass($params->csscategoryheader).' width="100%" valign="top">';
       echo '<a name="BM'.$alpha.'"></a>';    // Alpha Anchor
       echo $alpha;                           // Alpha Heading
       echo '&nbsp;</td>'."\n";
    } else {
       echo '     <td width="100%" valign="top">';
       echo '&nbsp;</td>'."\n";
    }

    echo '     <td class="button" nowrap="nowrap">';       // index
    if ( count($blocks) > 1 ) {
       foreach ($blocks as $block) {
          echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=".$params->navstart."&search=".$params->search). '#BM'.$block->car.'">' .$block->car. '</a>';
          if ($params->alphaindexsep2 == "S") {
             echo " ";
          } elseif ($params->alphaindexsep2 != "N") {
             echo $params->alphaindexsep2;
          }
       }
    }
    if ( $params->alphaindexsep2 == "N" ) { echo "&nbsp;"; }

    if ($params->showalphaindex) {
       echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=".$params->navstart."&search=".$params->search). '#BMIndex">'._BMU_TO_INDEX.'</a>';                // Alpha Index
    } else {
       echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=".$params->navstart."&search=".$params->search). '#top">'._BMU_TO_TOP.'</a>';                    // Back to top of page...
    }
    echo '</td>'."\n";                     // End index

    echo '    </tr>'."\n";
    echo '   </table>'."\n";

    echo '</td></tr>'."\n";
  }


function DisplayCatImageDesc ($option, $Itemid, $bmcat, &$params, &$blocks) {
    global $mosConfig_live_site;

    $mode = $params->mode;

    // *** Show Category Image & Description
    echo '<!-- Cat Description & Image -->'."\n";
    if ( ($bmcat->image) != '' || trim(strip_tags($bmcat->description)) != '' ) {
       echo '<tr class="contentdescription" align="left" valign="top"><td>'."\n";
       if ( $bmcat->image ) {
          $img='stories/'.$bmcat->image;
          $align=$bmcat->image_position;
          echo '<img src="' .$mosConfig_live_site. '/images/' .$img. '" align="' .$align. '" hspace="6" title="' ._BMU_jbd. ' : ' .htmlspecialchars($bmcat->cat, ENT_NOQUOTES). '" alt="' ._BMU_jbd. ' : ' .htmlspecialchars($bmcat->cat, ENT_NOQUOTES). '" />';

//     } else {   // Default image for categories, if none set...
//        $img='../components/com_jbd/images/jbd.png';       //  => We do prefer hidden if not set, as not set is not set, not with a default... :-)
//        $align='right';
//        echo '<img src="' .$mosConfig_live_site. '/images/' .$img. '" align="' .$align. '" hspace="6" title="' ._BMU_jbd. ' : ' .htmlspecialchars($bmcat->cat, ENT_NOQUOTES). '" alt="' ._BMU_jbd. ' : ' .htmlspecialchars($bmcat->cat, ENT_NOQUOTES). '" />';

       }
       if ( $bmcat->description != '' ) {
          if ($params->botsoncatdesc ) {  // Need to process Bots ?
             global $_MAMBOTS;

             $row->text = $bmcat->description;  // MosBot only uses field "text" => Need to copy "detail" content ...
             $row->images = "";                 // MosBot Need to simulate "images" field (must be present, but keep it empty)
             $row->sectionid = "";              // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
             $page = 0;                         // MosBot pagination system
             $prms = "";
             $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)

             echo '<!-- Bots -->'."\n";
             // Process the MosBots
             $_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
             $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );

             // Update field with processed text
             $bmcat->description = $row->text;
          }
          echo $bmcat->description;

//     } else {        // Default Description
//        echo _BMU_jbd_DESC;                                      //  => We do prefer hidden if not set, as not set is not set, not with a default... :-)

       }
       echo "\n".'</td></tr>'."\n";
    }
}

  function BackToIndexCat ($option, $Itemid, $bmcat, &$params, &$blocks, $last=false) {
    global $mosConfig_live_site;

    $mode = $params->mode;

    if ( ($mode == 0 && $params->showcattitle) || $mode > 0) {

       echo '<tr><td>'."\n";

       echo ' <table border="0" cellspacing="0" cellpadding="0" width="100%">'."\n";
       echo ' <tr>'."\n";

       if (!$last) {
          if ($params->showcaticon && $bmcat->icon) {
             echo '  <td nowrap="nowrap">';
             $iconurl = $mosConfig_live_site. '/images/stories/' .$bmcat->icon;
             echo '<img src="' .$iconurl. '" border="0" hspace="2" title="'.$bmcat->cat.'" alt="'.$bmcat->icon.'" />';
             echo '</td>'."\n";
          }
       }

       echo '  <td valign="bottom" width="100%">'."\n";                        // End Index

       echo '   <table border="0" cellspacing="0" cellpadding="0" width="100%">'."\n";
       echo '    <tr>'."\n";

       if (!$last) {
          echo '     <td '.mosjbdTools::cssClass($params->csscategoryheader).' width="100%" valign="top">';
          echo '<a name="BM'.$bmcat->id.'"></a>';
          $pos = strpos($bmcat->cat," / ");
          if ($pos != false) {
             $cat2 = substr($bmcat->cat,$pos+3);
          } else {
             $cat2 = $bmcat->cat;
          }
          echo $cat2;         // Cats Heading - Remove "RootCat" from Cat name
          echo '&nbsp;</td>'."\n";
       } else {
          echo '     <td width="100%" valign="top">';
          echo '&nbsp;</td>'."\n";
       }

       if ($mode != 0 || ($mode == 0 && $last) ) {  // Do not display Index/Top for OneCat mode or if it's the "last line" index
          echo '     <td class="button">';   // start index
          if ($params->showalphaindex) {
             echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=".$bmcat->id."&navstart=".$params->navstart."&search=".$params->search). '#BMIndex">'._BMU_TO_INDEX.'</a>';              // Cats Index
          } else {
             echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=".$bmcat->id."&navstart=".$params->navstart."&search=".$params->search). '#top">'._BMU_TO_TOP.'</a>';                    // Back to top of page...
          }
          echo '</td>'."\n";                 // End Index
       }

       echo '    </tr>';
       echo '   </table>'."\n";

       echo '  </td>';
       echo ' </tr>'."\n";
       echo ' </table>'."\n";

       echo '</td></tr>'."\n";

       if (!$last) {
          if ($params->showcatdesc == 1 || ( $params->showcatdesc == 2 && $mode == 0 ) || ( $params->showcatdesc == 3 && $mode == 2 ) ) {
             if ($params->showcatdescpos == 0) {
               HTML_jbd::DisplayCatImageDesc ($option, $Itemid, $bmcat, $params, $blocks);
             }
          }
       }
    }

  }


  function ShowDisplaymode($option, $Itemid, $catid, &$params) {
     global $mosConfig_live_site, $my;

     echo '  <tr><td'.mosjbdTools::cssClass($params->cssdisplaymode).'>';
     if ( _BMU_DISPLAY_MODE) { echo _BMU_DISPLAY_MODE . "&nbsp;"; };
     if ($params->mode == 0) { echo '<span'.mosjbdTools::cssClass($params->cssdisplaymodesel).'>['; }
        echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=0&catid=$catid&navstart=0&search=".$params->search). '">' ._BMU_DISPLAY_ONECAT. '</a>';
     if ($params->mode == 0) { echo ']</span>'; }
     echo '&nbsp;|&nbsp;';
     if ($params->mode == 1) { echo '<span'.mosjbdTools::cssClass($params->cssdisplaymodesel).'>['; }
     echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=1&catid=$catid&navstart=0&search=".$params->search). '">' ._BMU_DISPLAY_BYALPHA. '</a>';
     if ($params->mode == 1) { echo ']</span>'; }
     echo '&nbsp;|&nbsp;';
     if ($params->mode == 2) { echo '<span'.mosjbdTools::cssClass($params->cssdisplaymodesel).'>['; }
     echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=2&catid=$catid&navstart=0&search=".$params->search). '">' ._BMU_DISPLAY_BYCATS. '</a>';
     if ($params->mode == 2) { echo ']</span>'; }
     echo '&nbsp;|&nbsp;';
     if ($params->mode == 3) { echo '<span'.mosjbdTools::cssClass($params->cssdisplaymodesel).'>['; }
     echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=3&catid=$catid&navstart=0&search=".$params->search). '">' ._BMU_DISPLAY_ALLALPHA. '</a>';
     if ($params->mode == 3) { echo ']</span>'; }
     echo '</td></tr>'."\n";

  }


  function ShowNavigator($option, $Itemid, $catid, &$params) {
     global $mosConfig_live_site, $my;


     if ($params->navtotal > 0) {
        $params->navpos = $params->navstart*$params->navperpage;
        $params->navposend = ($params->navtotal > (($params->navstart+1)*$params->navperpage)-1 ) ? ($params->navstart+1)*$params->navperpage-1 : $params->navtotal-1;
        $params->navprev = ($params->navstart > 0) ? $params->navstart-1 : 0;
        $params->navnext = ($params->navtotal > $params->navposend) ? $params->navstart+1 : $params->navstart+1 ;
        $params->navhide = 5;

        echo '  <tr><td align="center">';
//        if ( $params->navperpage > 0 ) {                        // To display Navigator if there is some jbd to display, even ther is only one item...
        if ( $params->navperpage > 0 && $params->navtotal > $params->navperpage) {    // To display Navigator if there is some jbd to display, even ther is only one item...

           // ** START
           echo '<span class="pagenav">';
           if ($params->navstart > 0) {
              echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=0&search=".$params->search). '">';
           }
           echo '&lt;&lt;&nbsp;' . _PN_START;
           if ($params->navstart > 0) {
              echo '</a>';
           }
           echo '</span>';

           echo ' ';

           // ** PREVIOUS
           echo '<span class="pagenav">';
           if ($params->navstart > 0) {
             echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=".$params->navprev."&search=".$params->search). '">';
           }
           echo '&lt;&nbsp;' . _PN_PREVIOUS;
           if ($params->navstart > 0) {
              echo '</a>';
           }
           echo '</span>';

           echo ' ';
           // ** PAGES
           for ($i=0; $i <= $params->navend; $i++) {

             if ( ($i == $params->navstart-$params->navhide-1) || ($i == $params->navstart+$params->navhide+1) ) {
                echo '<span class="pagenav">...</span>';
                echo ' ';
             } else if ( ($i > $params->navstart-$params->navhide-1) && ($i < $params->navstart+$params->navhide+1) ) {
                echo '<span class="pagenav">';
                if ($params->navstart == $i) {
                   echo '<b>[';
                }
                echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=$i&search=".$params->search). '">';
                echo $i+1;
                echo '</a>';
                if ($params->navstart == $i) {
                   echo ']</b>';
                }
                echo '</span>';
                echo ' ';
             }
           }

           // ** NEXT
           echo '<span class="pagenav">';
           if ($params->navnext <= $params->navend) {
             echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=".$params->navnext."&search=".$params->search). '">';
           }
           echo _PN_NEXT . '&nbsp;&gt;';
           if ($params->navnext <= $params->navend) {
              echo '</a>';
           }
           echo '</span>';

           echo ' ';

           // ** END
           echo '<span class="pagenav">';
           if ($params->navstart < $params->navend) {
              echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=".$params->navend."&search=".$params->search). '">';
           }
           echo _PN_END . '&nbsp;&gt;&gt;';
           if ($params->navstart < $params->navend) {
              echo '</a>';
           }
           echo '</span>';

           // *** "Split Results ?" => [True] : Results on a second line / [False] : Result on same line as navigator !
           echo (true) ? "<br />\n" : "&nbsp;/&nbsp;";
        }

        if ($params->shownavresults) {
           // ** Display Navigator Results
           echo _PN_RESULTS . ": ";
           echo ($params->navtotal > 0) ? ($params->navpos+1) : 0;
           echo " - ";
           if ($params->navperpage > 0) {
              echo ($params->navpos + $params->navperpage <= $params->navtotal) ? $params->navpos+$params->navperpage : $params->navtotal;
           } else {
              echo $params->navtotal;
           }
           echo " ". _PN_OF . " " . $params->navtotal."\n";
        }
        echo '</td></tr>'."\n";

     }
  }


  function ShowSubmit($option, $Itemid, $catid, &$params) {
     global $mosConfig_live_site, $my;

     if ( ( $params->cansubmit && $my->gid >= $params->submitlevel ) || $params->forcesubmitlink ) {
        echo '  <tr><td>';
        echo '<img src="' .$mosConfig_live_site. '/images/M_images/new.png" width="13" height="14" align="middle" border="0" alt="' ._BMU_SUBMIT_NEW. '" hspace="2" />';
        echo '<a href="' .sefRelToAbs("index.php?option=$option&task=new&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&navstart=0&search=".$params->search). '">';
        echo _BMU_SUBMIT_NEW;
        echo '</a>';
        echo '</td></tr>'."\n";
     }
  }


  function BMSortArrow ($option, $Itemid, $catid, $orderby, $orderbyupdown, $curorderby, &$params) {
    if ($params->showheadersort) {
       $img = "components/com_jbd/images/";
       $img .= ($orderbyupdown == 'asc') ? "up" : "down";
       $selected = (strtolower($orderby) == $curorderby);
       $img .= ($selected) ? "_selected.png" : ".png";
       if ($selected) {
          $orderbyupdown = ($orderbyupdown == "asc") ? "desc" : "asc";     // Invert sort for link...
       }
       echo '<a href="' .sefRelToAbs("index.php?option=$option&task=order&Itemid=$Itemid&mode=".$params->mode."&catid=$catid&orderbycol=$orderby&orderbyupdown=$orderbyupdown&search=".$params->search). '"><img src="' .$img. '" border="0" hspace="2" alt="" /></a>';
    }
  }



  function displayHeader (&$option, &$Itemid, &$catid, &$nbcols, &$hidecols, &$nbcol, &$orderbycol, &$orderbyupdown, &$params, &$access) {
          global $my,$mosConfig_live_site;

          if ($nbcols==0) { $nbcols = 1; }

          echo '<!-- jbd Header -->'."\n";
          if ($params->showheader) {
             echo '      <tr valign="middle">'."\n";
          }

          for ($col=0; $col <= (($nbcols-1) - $hidecols); $col++) {  // Multi-columns

            $nbcol = 0;

            if ($col > 0) {
               if ($params->showheader) {
                  echo '        <td width="17"'.mosjbdTools::cssClass($params->csstableheader).'align="center" nowrap="nowrap" valign="middle" style="background-image: url(' .$mosConfig_live_site. '/components/com_jbd/images/separator.png);">';
                  echo '</td>'."\n";
               }
            }

            // *** Edit jbd icon
            if ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) ) {
               if ($params->showheader) {
                  echo '        <td width="17" align="center"'.mosjbdTools::cssClass($params->csstableheader).'>&nbsp;</td>'."\n";
               }
            }


            foreach ($params->columns as $column) {

              // *** Column : Icons
              if ($column->name == "icon" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="20" align="center"'.mosjbdTools::cssClass($params->csstableheader).'>&nbsp;</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : jbd
              if ($column->name == "business" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="';
                    echo ( mosjbdTools::isColVisible('description', $params->columns) && !$params->showdescsplit ) ? floor(45/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                    echo '" align="left" nowrap="nowrap"'.mosjbdTools::cssClass($params->csstableheader).'>';
                    echo _BMU_jbd;
                    if ($params->bmsort == 1) {
                       HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'ordering', $orderbyupdown, $orderbycol, $params );
                    } elseif ($params->bmsort == 2) {
                       HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'created', $orderbyupdown, $orderbycol, $params );
                    } else {
                       HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'title', $orderbyupdown, $orderbycol, $params );
                    }
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Description
              if ( $column->name == "description" && $column->visible && ( !$params->showdescsplit || ( !mosjbdTools::isColVisible ('business', $params->columns) && $params->showdescsplit==1 ) ) ) {
                 if ($params->showheader) {
                    echo '        <td';
                    if ($nbcols-$hidecols > 1) {
                       echo ' width="';
                       echo ( mosjbdTools::isColVisible ('business', $params->columns) ) ? floor(55/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                       echo '"';
                    }
                    echo ' align="left" nowrap="nowrap"'.mosjbdTools::cssClass($params->csstableheader).'>';
                    echo _BMU_DESCRIPTION;
                    HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'description', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

                 // *** Column : Image  (sorted by Title)
              if ($column->name == "image" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="';
                    echo ( !mosjbdTools::isColVisible ('business', $params->columns) && !mosjbdTools::isColVisible ('description', $params->columns) ) ? floor(100/($nbcols-$hidecols)).'%' : '60';
                    echo '" align="left" nowrap="nowrap"'.mosjbdTools::cssClass($params->csstableheader).'>';
                    echo _BMU_IMAGE;
                    if ($params->bmsort == 1) {
                       HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'ordering', $orderbyupdown, $orderbycol, $params );
                    } elseif ($params->bmsort == 2) {
                       HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'created', $orderbyupdown, $orderbycol, $params );
                    } else {
                       HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'title', $orderbyupdown, $orderbycol, $params );
                    }
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Rating
              if ($params->canvote && $column->name == "rating" && $column->visible ) {
                 if ($params->showheader) {
                    $disp = (($params->canvotedetail == 0 || $params->canvotedetail == 1) && $my->gid >= $params->votelevel) ? 1 : 0;
                    echo '        <td width="';
                    if ($disp) {
                       switch ($params->showratingsplit) {
                         case "1" :
                             echo '100';     // for stars above the vote button
                             break;
                         case "2" :
                             echo '60';      // for the all elements on the same line
                             break;
                         case "0" :
                         default :
                             echo '160';     // for elements on 3 lines
                       }
                    } else {                 // Not allowed to vote => Only Stars
                      echo '60';
                    }
                    echo '" align="center" nowrap="nowrap"'.mosjbdTools::cssClass($params->csstableheader).'>'."\n";
                    echo _BMU_RATING;
                    HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'rating', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Hits
              if ($column->name == "hits" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="60" align="center" nowrap="nowrap"'.mosjbdTools::cssClass($params->csstableheader).'>';
                    echo _BMU_HITS;
                    HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'hits', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Date
              if ($column->name == "created" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="110" align="left" nowrap="nowrap"'.mosjbdTools::cssClass($params->csstableheader).'>';
                    echo _BMU_DATE;
                    HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'created', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Publisher (created_by)
              if ($column->name == "created_by" && $column->visible ) {
                 if ($params->showheader) {
                    echo '        <td width="80" align="left" nowrap="nowrap"'.mosjbdTools::cssClass($params->csstableheader).'>';
                    echo _BMU_PUBLISHER;
                    HTML_jbd::BMSortArrow($option, $Itemid, $catid, 'created_by', $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }

              // *** Column : Custom Fields
              if ($column->custom == 1 && $column->visible && ( $column->f_type != 8 || ($column->f_type == 8 && $params->canvote) ) ) {
                 if ($params->showheader) {
                    $name = $column->name;
                    if ($column->f_type == 8) {
                       echo '        <td width="';
                       echo ( $params->showratingsplit ) ? '60' : '120';
                       echo '" align="center" class="sectiontableheader" nowrap="nowrap">';
                    } else {
                       echo '        <td width="60" align="left" nowrap="nowrap"'.mosjbdTools::cssClass($params->csstableheader).'>';
                    }
                    echo $column->title;
                    HTML_jbd::BMSortArrow($option, $Itemid, $catid, $name, $orderbyupdown, $orderbycol, $params );
                    echo '</td>'."\n";
                 }
                 $nbcol++;
              }


            } // Show column header loop

            if ( !mosjbdTools::isColVisible('business', $params->columns)
                 && !mosjbdTools::isColVisible('description', $params->columns)
                 && !mosjbdTools::isColVisible('image', $params->columns)
               ) {
               if ($params->showheader) {
                  echo '        <td width="'.floor(100/($nbcols-$hidecols)).'%" align="left" nowrap="nowrap"'.mosjbdTools::cssClass($params->csstableheader).'>&nbsp;</td>'."\n";
               }
               $nbcol++;
            }

          } // multi columns

          if ($params->showheader) {
             echo '      </tr>'."\n";
          }


}


// ***********************************
// ***                              **
// ***  Display the jbd List  **
// ***                              **
// ***********************************


  function displaylist( $option, &$categories, &$rows, $catid, &$currentcat, $pathcat, &$lists, $access, $msg, $orderbycol, $orderbyupdown, &$params ) {
    global $database, $Itemid, $mosConfig_live_site, $my, $_MAMBOTS;

    echo "\n".'<!-- ### START Component : Business Directory (c) www.meesaw.com '.mosjbd::getVersion().' ### -->'."\n\n";

    $params->_Itemid = $Itemid;
    $params->_option = $option;
    $params->_catid = $catid;

    // *** Init Ovelib Library (if not already present...)
    echo mosjbdTools::overlibInitCallBM();

//    echo "DEBUG: 2 catid : ".$catid."<br />\n";
//    echo "DEBUG: Records : ".$params->navtotal."<br />\n";

    echo '<a name="BMIndex"></a>'."\n"; // Anchor to come back to index.

/*
foreach ($rows as $r) {
  echo '<span style="color: Green; font-weight: bold;">DEBUG</span> ';
  foreach ($r as $k=>$v) {
    echo "| <b>$k</b>: $v ";
  }
  echo "<br /><hr />\n";
}
*/

    // MosBot : Convert "$params" to "mosParameters" format
    $prms = "";
    $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)
    foreach ($params as $k=>$v) {
       $bmparams->def($k,$v);
    }


    // *** Component Table (master)
    echo '<table class="contentpane" border="0" cellpadding="' .$params->paddingheader. '" cellspacing="0" width="100%">'."\n";

    // *** System message (After new submission)
    echo '<!-- Message -->'."\n";
    switch ($msg) {
      case "msg1" :
          $message = _BMU_ITEM_ADDED_MUST_APPROVED_BY_ADMIN;
          break;
      case "msg2" :
          $message = _BMU_MAIL_SENT;
          break;
      default :
          $message = '';
    }

    if ( $message ) {
       echo '  <tr align="center"><td><b>' .$message. '</b></td></tr>'."\n";
       echo '  <tr><td>&nbsp;</td></tr>'."\n";
    }

    echo '<!-- Page Title -->'."\n";
    if ($params->showpagetitle) {
       echo (_BMU_business_LIST) ? '<tr><td><div class="componentheading">'._BMU_business_LIST.'</div></td></tr>'."\n" : "";
    }

    echo '<!-- Component Header -->'."\n";
    if ($params->comheaderlist) {
       if ($params->comheaderlist && $params->botsonheaderlist) {
          // MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
          $row->text = $params->comheaderlist;   // MosBot only uses field "text" => Need to copy "detail" content ...
          $row->images = "";                     // MosBot Need to simulate "images" field (must be present, but keep empty)
          $row->sectionid = "";                  // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
          $page = 0;                             // MosBot pagination system

          // Process the MosBots
          $_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
          $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
          $params->comheaderlist = $row->text;
       }
       echo '<tr><td><div class="contentpane">';
       echo $params->comheaderlist;
       echo '</div></td></tr>'."\n";
    }

    // *** Show Display Mode Navigation
    echo '<!-- Navigation : Display Mode -->'."\n";
    if ($params->showdisplaymode) {
       HTML_jbd::ShowDisplaymode($option, $Itemid, $catid, $params);
    }

    // *** Show Display Seach Index
    echo '<!-- Search Index -->'."\n";
    if ( $params->showalphaindex || $params->showsearchbox) {
       HTML_jbd::ShowAlphaIndex($option, $Itemid, $catid, $params);
    }

    // *** Show Submission link on TOP
    echo '<!-- Submit New (Top) -->'."\n";
    if ($params->submitpos == '1') {
       HTML_jbd::ShowSubmit($option, $Itemid, $catid, $params);
    }

    // *** Show Pathway
    echo '<!-- Pathway -->'."\n";
    if ($params->mode == 0 && ($params->showpathway == 1 || $params->showpathway == 2) ) {
       echo '  <tr><td>' .$pathcat. '</td></tr>'."\n";
    }

    // *** Show Categories on TOP
    echo '<!-- Categories (TOP) -->'."\n";
    if ($params->catpos == '1' && $params->mode == 0 && $params->showcats) {
       switch ($params->catdisplayorder) {
         case "1" :
             HTML_jbd::ShowCatsHoriz($option, $catid, $categories, $Itemid, $params);
             break;
         case "2" :
             HTML_jbd::ShowCatsTree($option, $catid, $categories, $Itemid, $params);
             break;
         case "0" :
         default :
             HTML_jbd::ShowCatsVert($option, $catid, $categories, $Itemid, $params);
       }
    }


    // *** Show Navigator on TOP
    echo '<!-- Navigator (Top) -->'."\n";
    if ($params->navigatorpos == '1' || $params->navigatorpos == '3') {
          HTML_jbd::ShowNavigator($option, $Itemid, $catid, $params);
    }


    $blockfirst = 0;
    $blocklast = 0;

    $blocks = array();
    $block = 0;

    if ($params->mode == 0) {    // Display : One Cat
       $blocks[$block]->block = -1;
       $blocks[$block]->car = HTML_jbd::alphaV(-1);
       $blocks[$block]->first = $blockfirst;
       $blocks[$block]->last = count($rows);
       $blocks[$block]->cat = $currentcat->name;              // First Category : Name
       $blocks[$block]->catdesc = $currentcat->description;   // First Category : Description
       $blocks[$block]->car = "";
    }

    if ($params->mode == 3) {    // Display : Alpha not grouped
       $blocks[$block]->block = -1;
       $blocks[$block]->car = HTML_jbd::alphaV(-1);
       $blocks[$block]->first = $blockfirst;
       $blocks[$block]->last = count($rows);
       $blocks[$block]->car = "";
    }

    if ($params->mode == 1 && count($rows) > 0) {    // Display : By Alpha
       $check = 0; // char to check...
       while ( $blocklast < count($rows) ) {  // scan All records
          if ( strtoupper(substr($rows[$blocklast]->title,0,1)) < HTML_jbd::alphaTest($check) ) {      // search last item of the block ( less than next block )
             $blocklast++;   // Item in block
          } else {
             if ($blocklast == $blockfirst) {   // There are item(s) in this block => display...
             } else {
                $blocks[$block]->block = $block;
                $blocks[$block]->first = $blockfirst;
                $blocks[$block]->last = $blocklast;
                $blocks[$block]->car = HTML_jbd::alphaV($check);
                $blocks[$block]->cat = "";
                $block++;                   // Next Block
                $blockfirst = $blocklast;   // Begin of next group
             }
             $check++;       // check next char block
          }
       }
       $blocks[$block]->block = $block;      // Last Block
       $blocks[$block]->first = $blockfirst;
       $blocks[$block]->last = count($rows);
       $blocks[$block]->car = HTML_jbd::alphaV($check);
       $blocks[$block]->cat = "";
    }

    if ($params->mode == 2 && count($rows) > 0) {    // Display : By Cats
       $lastcat = strtolower($rows[$blocklast]->category);   // First Category
       while ( $blocklast < count($rows) ) {  // scan All records
          if ( strtolower($rows[$blocklast]->category) == $lastcat ) {      // search last item of the block ( less than next block )
             $blocklast++;   // Item in block
          } else {
             $blocks[$block]->block = $block;
             $blocks[$block]->first = $blockfirst;
             $blocks[$block]->last = $blocklast;
             $blocks[$block]->cat = $rows[$blockfirst]->category;      // Categoy : Name
             $blocks[$block]->catdesc = $rows[$blockfirst]->catdesc;   // Category : Description
             $blocks[$block]->car = "";
             $block++;                   // Next Block
             $blockfirst = $blocklast;   // Begin of next group
             $lastcat = strtolower($rows[$blocklast]->category);       // check next cat block
          }
       }
       $blocks[$block]->block = $block;   // last block
       $blocks[$block]->first = $blockfirst;
       $blocks[$block]->last = count($rows);
       $blocks[$block]->cat = $rows[$blockfirst]->category;
       $blocks[$block]->car = "";
    }

    $nbcol = 0;

    $params->showsnapshoterpic = 0;  // Var Init to know if we have to display the Snapshoter's free service picture (adv)

    if ( count($rows) > 0 ) {  // Item(s) to display...
       for ($block=0; $block < count($blocks); $block++) {

          // *** Show Display BackTo Index (Group Header)
          if ($block > 0) {
             echo '<!-- Section Separator -->'."\n";
             echo '<tr><td>&nbsp;</td></tr>'."\n";  // Section separator
          }

/*
      echo "<tr><td>\n";
      echo "DEBUG: blockfirst: " .$blocks[$block]->first. "  blocklast: " .$blocks[$block]->last. "<br />\n";
      echo "DEBUG: [ Block: ".$blocks[$block]->block." / Car: " .$blocks[$block]->car. " / Cat: " .$blocks[$block]->car. " ]<br />\n";
      echo "</td></tr>\n";
*/

          // *** Show Display BackTo Index (Group Header)
          echo '<!-- Search BackTo Index -->'."\n";

          switch ($params->mode) {
            case 0 :   // One Cat
                $trow = $currentcat;       // User Current Cat as Cat Block
                $bmcat->id = $trow->id;
                $bmcat->cat = $trow->name;
                $bmcat->description = $trow->description;
                $bmcat->image = $trow->image;
                $bmcat->image_position = $trow->image_position;
                $bmcat->icon = $trow->icon;
                HTML_jbd::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks );
                break;
            case 1 :   // Alpha Grouped
                HTML_jbd::BackToIndexAlpha ($option, $Itemid, $catid, $params, $blocks[$block]->car, $blocks );
                break;
            case 2 :   // Cat Grouped
                $trow = $rows[$blocks[$block]->first];       // Display item within block at correct grid position
                $bmcat->id = $trow->catid;
                $bmcat->cat = $trow->category;
                $bmcat->description = $trow->catdesc;
                $bmcat->image = $trow->image;
                $bmcat->image_position = $trow->image_position;
                $bmcat->icon = $trow->icon;
                HTML_jbd::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks );
                break;
            case 3 :   // Cat Grouped
                $trow = $rows[$blocks[$block]->first];       // Display item within block at correct grid position
                $bmcat->id = $params->_catid;
                break;
            default :    // Other
          }

          $items = $blocks[$block]->last - $blocks[$block]->first;
          $nbcols = $params->nbcolumns;
          $nbrows = ceil($items / $nbcols);
          $max = $nbrows * $nbcols;
          $fullrows = ($nbcols-1)*($nbrows);
          $hidecols = 0;

          if ($params->mode == 0) {
             for ($c=0; $c < $nbcols; $c++) {   // Check is a some columns will stay blank on right
                $item = ($c * $nbrows);
                if ($item > $items-1) {
                   $hidecols++;
                }
             }
          }



          // *** Display jbd Lists (if any found...)
          echo '<!-- jbd -->'."\n";
          if ( count( $items ) ) {

          echo '  <tr><td>'."\n";

          echo '<!-- jbd Popup Script -->'."\n";
          mosjbdTools::bm_popup($params);   // Load jbd popup script

          echo '<!-- Custom Field Popup Script -->'."\n";
          mosjbdTools::f_popup($params);   // Load Custom Fields popup script

          echo '    <table class="contentpane" width="100%" border="0" cellspacing="0" cellpadding="' .$params->paddingcolumns. '">'."\n";


          HTML_jbd::displayHeader ($option, $Itemid, $catid, $nbcols, $hidecols, $nbcol, $orderbycol, $orderbyupdown, $params, $access);


          // *** Display jbd rows

          $tabclass = array("sectiontableentry1", "sectiontableentry2");
          $alternate = 0;

          $item = 0;

          $params->showsnapshoterpic = 0;

          echo '<!-- jbd Rows-->'."\n";

          if ($params->botsonbmdesc) {  // Process Bots only is allowed => may produce Performance issue is Bots are performed...
             $_MAMBOTS->loadBotGroup( 'content' );  // Load published Bots from "Content" folder
          }

          for ($line=0; $line < $nbrows; $line++) {

              echo '      <tr class="' .$tabclass[$alternate]. '" valign="top">'."\n";

              for ($col=0; $col <= (($nbcols-1) - $hidecols); $col++) {

                  $item = ($col*$nbrows) + $line;                      // Compute grid position

                  if ( $item < $items ) {
                     $row = $rows[$blocks[$block]->first+$item];       // Display item within block at correct grid position

                     $valid_status = "";
                     $valid_img = "";

                     if ( $params->botsonbmdesc && mosjbdTools::isColVisible ('description', $params->columns) && trim(strip_tags($row->description)) ) {
                        // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
                        $row->text = $row->description;  // MosBot only uses field "text" => Need to copy "detail" content ...
                        $row->images = "";               // MosBot Need to simulate "images" field (must be present, but keep empty)
                        $row->sectionid = "";            // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                        $page = 0;                       // MosBot pagination system
                        // Process the MosBots
                        $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                        $row->description = $row->text;   // Return Converted text...
                     }

                     if ( $params->markvalidate ) {
                       mosjbdTools::ValidationInfo ($params, $row, $valid_status, $valid_img);
                     }

                     $picurl = mosjbdTools::prepareImageUrl($params, $row, true);

                     $overlibtxt = mosjbdTools::prepareOverlibBox($params, $row, $params->showurldetails, $picurl, $valid_status, $valid_img);

                     if ($row->redirect) {        // Show Detail page
                        $anchor = '<a href="'. sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=detail&catid=$catid&navstart=".$params->navstart."&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '"'.mosjbdTools::cssClass($params->cssjbd).' ' .$overlibtxt. '>';
                        $anchorend = '</a>';
                     } else {                     // Open URL
                        if ($row->url != "") {              // URL => Redirection...
                          if ($params->directurl) {                      // Use direct URL => No Hits Count !!!!
                             $anchor = '<a href="' .sefRelToAbs($row->url). '"';
                             if ($row->openwin == 0 || $row->openwin == 4) {   // Open url in the parent page
                                $anchor .= ' target="_parent"';
                             } else {                                          // Open url in a new page (also for Wrapper)
                                $anchor .= ' target="_blank"';
                             }
                          } else {
                             switch ($row->openwin) {
                               case "0" :
                                   $anchor = '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=view&id=".$row->id). '"';
                                   $anchor .= ' target="_parent"';
                                   break;
                               case "2" :    // Open url in Wrapper
                                   $anchor = '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=wrapper&id=".$row->id). '"';
                                   break;
                               case "3" :    // Open Direct url (Blank)
                                   $anchor = '<a href="' .sefRelToAbs($row->url). '"';
                                   $anchor .= ' target="_blank"';
                                   break;
                               case "4" :    // Open Direct url (Parent)
                                   $anchor = '<a href="' .sefRelToAbs($row->url). '"';
                                   $anchor .= ' target="_parent"';
                                   break;
                               case "1" :
                               default :
                                   $anchor = '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=view&id=".$row->id). '"';
                                   $anchor .= ' target="_blank"';
                             }
                          }

                          $anchor .= mosjbdTools::cssClass($params->cssjbd);
                          $anchor .= $overlibtxt;
                          $anchor .= '>';
                          $anchorend = '</a>';
                        } else {                            // No URL => No redirection...
                          if ($params->emptyurlnolink) {
                            $anchor = '<span '.mosjbdTools::cssClass($params->cssjbd).' ' .$overlibtxt. '>';
                            $anchorend = '</span>';
                          } else {
                            $anchor = '<a href="javascript:void(0);"'.mosjbdTools::cssClass($params->cssjbd).' ' .$overlibtxt. '>';
                            $anchorend = '</a>';
                          }
                        }
                     }

                     // ** Column : Separator (if multiple columns)
                     if ($col > 0) {
                        echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="17" align="center" nowrap="nowrap" valign="middle" style="background-image: url(' .$mosConfig_live_site. '/components/com_jbd/images/separator.png);">';
                        echo '</td>'."\n";
                     }


                     // *** Column : Edit jbd icon
                     if ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) ) {
                        echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="17" align="center" valign="top" nowrap="nowrap">';
                        if (  $access->canEdit || ( $row->created_by == $my->id && $access->canEditOwn ) || ( $params->regcaneditown && $row->created_by == $my->id ) ) {
                           echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=edit&catid=$catid&navstart=".$params->navstart."&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '" title="' ._E_EDIT. ' : ' .htmlspecialchars($row->title, ENT_NOQUOTES). '">';
                           echo '<img src="' .$mosConfig_live_site. '/images/M_images/edit.png" align="middle" border="0" alt="' ._E_EDIT. '" />';
                           echo '</a>';
                        } else {
                            echo '&nbsp;';
                        }
                        echo '</td>'."\n";
                     }

                     // *** Display each columns according to their order defined in Columns Editor...
                     foreach ($params->columns as $column) {

                       // *** Column : Icons
                       if ($column->name == "icon" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="20" align="left" nowrap="nowrap">';
                          echo $anchor;
                          echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/html.png" border="0" alt="" />';
                          echo $anchorend."\n";
                       }

                       // *** Column : jbd
                       if ($column->name == "business" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="';
                          echo ( mosjbdTools::isColVisible('description', $params->columns) && !$params->showdescsplit ) ? floor(45/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                          echo '"';
                          echo ' align="left">';
                          echo $anchor;
                          echo $row->title;
                          echo $anchorend.' ';

                          if ($params->showdetaillink == 2 || ($params->showdetaillink == 1 && $row->redirect != 1 && trim(strip_tags($row->detail)) ) ) {
                             echo '<a href="'. sefRelToAbs("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=detail&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '">';
                             echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/opendetail.png" border="0" alt="" title="'._BMU_OPEN_DETAIL.'" />';
                             echo '</a>&nbsp;';
                          }

                          if ($params->canrecommend && $my->id) {
                             echo '<a href="'. sefRelToAbs("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=recommend&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '">';
                             echo '<img src="' .$mosConfig_live_site. '/images/M_images/emailButton.png" border="0" alt="' ._BMU_RECOMMEND. '" title="'._BMU_RECOMMEND.'" />';
                             echo '</a>&nbsp;';
                          }

                          if ($row->ratingadmin) {
                             if ($row->ratingadmin == 1) { // Bronze
                                echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/isbronze.png" border="0" alt="' ._BMU_ISBRONZE. '" title="'._BMU_ISBRONZE.'" />&nbsp;';
                             } else {  // Gold
                                echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/isgold.png" border="0" alt="' ._BMU_ISGOLD. '" title="'._BMU_ISGOLD.'" />&nbsp;';
                             }
                          }

                          if ($params->showpoplast) {
                             $created = mosjbdTools::calcElapsedDays( $row->created );
                             if ($created->days <= $params->showpoplast) {
                                echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/isnew.png" border="0" alt="' ._BMU_ISNEW. '" title="'._BMU_ISNEW.' ('.$created->days.' '._BM_DAYS.')" />&nbsp;';
                             }
                          }

                          if ($params->showpoptop && $params->canvote) {
                             if ($row->rating >= $params->showpoptop) {
                                echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/istop.png" border="0" alt="' ._BMU_ISTOP. '" title="'._BMU_ISTOP.' ('.$row->rating.')" />&nbsp;';
                             }
                          }

                          if ($params->showpopbest) {
                             if ($row->hits >= $params->showpopbest) {
                                echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/isbest.png" border="0" alt="' ._BMU_ISBEST. '" title="'._BMU_ISBEST.' ('.$row->hits.')" />&nbsp;';
                             }
                          }

                          if ( $row->url && ( $params->markvalidate == 2 || $params->markvalidate == 3 ) ) {
                             if ($params->validatefront && ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) )) {
                                echo '<a href="'. sefRelToAbs("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=check&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '">';
                             }
                             echo '<img src="'.$valid_img.'" border="0" title="'.mosjbdTools::SafeQuotes(strip_tags($valid_status), false).'" alt="" />';
                             if ($params->validatefront && ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) )) {
                                echo '</a>';
                             }
                             echo '&nbsp;';
                          }

                          if ( $row->private && ( $params->markprivate == 2 || $params->markprivate == 3 ) && $params->allowprivate ) {
                             echo '<span style="color: Red; font-weight: bold;" title="' ._BMU_PRIVATE. ' : '.$row->username.'">'._BMU_PRIVATE_MARK.'</span>&nbsp;';
                          }
                          echo ( $params->showdescsplit == 1 && mosjbdTools::isColVisible ('description', $params->columns) && trim(strip_tags($row->description)) ) ? "<br />".$row->description : "";
                          echo '</td>'."\n";
                       }

                       // *** Column : Description
                       if ( $column->name == "description" && $column->visible && ( !$params->showdescsplit || ( !mosjbdTools::isColVisible ('business', $params->columns) && $params->showdescsplit==1 ) ) ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="';
                          echo ( mosjbdTools::isColVisible('description', $params->columns) && !$params->showdescsplit ) ? floor(55/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                          echo '"';
                          echo ' align="left">';
                          echo ( trim(strip_tags($row->description)) ) ? $row->description : "&nbsp;";
                          echo '</td>'."\n";
                       }

                       // *** Column : Image
                       if ($column->name == "image" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="';
                          echo ( !mosjbdTools::isColVisible ('business', $params->columns) && !mosjbdTools::isColVisible ('description', $params->columns) ) ? floor(100/($nbcols-$hidecols)).'%' : '60';
                          echo '"';
                          if ($params->showimagesplit && $params->showdescsplit == 2) {
                             echo ' rowspan="2"';
                          }
                          echo ' align="left" nowrap="nowrap">';
                          if ( $row->imageurl != '' ) {
                             echo $anchor;
                             echo '<img src="' .$picurl. '" border="0" align="left" hspace="2" alt=""';
                             if ($params->imgforcewidth) {
                                echo ' width="' .$params->imgforcewidth. '"';    // To force the image size...
                             }
                             if ($params->imgforceheight) {
                                echo ' height="' .$params->imgforceheight. '"';    // To force the image size...
                             }
// !!pic
//                             echo ' onload="if(this.width==1){this.width=\'120\';this.height=\'90\'}"';   // Thumbshot "Preview Not found" is 1x1 pixel => force to 120x90...
                             echo ' />';
                             echo $anchorend.'<br />';
                          } else {
                             echo '&nbsp;';
                          }
                          echo '</td>'."\n";
                       }

                       // *** Column : Rating
                       if ($params->canvote && $column->name == "rating" && $column->visible ) {
                          $disp = (($params->canvotedetail == 0 || $params->canvotedetail == 1) && $my->gid >= $params->votelevel) ? 1 : 0;
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="';
                          if ($disp) {
                             switch ($params->showratingsplit) {
                               case "1" :
                                   echo '100';     // for stars above the vote button
                                   break;
                               case "2" :
                                   echo '60';      // for the all elements on the same line
                                   break;
                               case "0" :
                               default :
                                   echo '160';     // for elements on 3 lines
                             }
                          } else {                 // Not allowed to vote => Only Stars
                            echo '60';
                          }
                          echo '" align="center" nowrap="nowrap">'."\n";
                          echo mosjbdTools::displayRating ('rating', $row, $column, $params, true, $disp, $lists->rating);
                          echo '        </td>'."\n";
                       }


                       // *** Column : Hits
                       if ($column->name == "hits" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="60" align="center" nowrap="nowrap">' .number_format($row->hits, 0, _BMU_FMT_DECIMAL, _BMU_FMT_THOUSAND). '&nbsp;</td>'."\n";
                       }

                       // *** Column : Date
                       if ($column->name == "created" && $column->visible ) {
                          echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="110" align="left" nowrap="nowrap">' .mosFormatDate( $row->created ). '&nbsp;</td>'."\n";
                       }

                       // *** Column : Publisher
                       if ($column->name == "created_by" && $column->visible ) {
                           echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="60" align="left" nowrap="nowrap">' .$row->username. '&nbsp;</td>'."\n";
                       }

                       if ($column->custom == 1 && $column->visible && ( $column->f_type != 8 || ($column->f_type == 8 && $params->canvote) ) ) {
                          $name = 'f_'.$column->name;
                          if ($column->f_type == 8) {
                             $disp = (($params->canvotedetail == 0 || $params->canvotedetail == 1) && $my->gid >= $params->votelevel) ? 1 : 0;
                             echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="';
                             if ($disp) {
                                switch ($params->showratingsplit) {
                                  case "1" :
                                      echo '100';     // for stars above the vote button
                                      break;
                                  case "2" :
                                      echo '60';      // for elements on 3 lines
                                      break;
                                  case "0" :
                                  default :
                                      echo '160';     // for the all elements on the same line
                                }
                             } else {                 // Not allowed to vote => Only Stars
                               echo '60';
                             }
                             echo '" align="center" nowrap="nowrap">'."\n";
                             echo mosjbdTools::displayCustom ($name, $row, $column, $params, true, $disp, $lists->$name);
                          } else {

                             echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="40" align="';
                             if ($column->f_type == 6 || $column->f_type == 7) {  //  "center" align for URL and Mail fields
                                echo 'center';
                             } else {
                                echo 'left';
                             }
                             echo '" nowrap="nowrap">';
                             echo mosjbdTools::displayCustom ($name, $row, $column, $params);
                             echo '&nbsp;';
                          }
                          echo '</td>'."\n";
                       }

                     } // Columns Loop

                     // *** add a special blank columns to push columns to left...
                     if ( !mosjbdTools::isColVisible('business', $params->columns)
                          && (!mosjbdTools::isColVisible('description', $params->columns) || ( mosjbdTools::isColVisible('description', $params->columns) && $params->showdescsplit) )
                          && !mosjbdTools::isColVisible('image', $params->columns)
                        ) {
                        echo '        <td';
                          if ($row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="'.floor(100/($nbcols-$hidecols)).'%" align="left" nowrap="nowrap">&nbsp;</td>'."\n";
                     }

                  } else {       // Display blank cells

                     if ($col <= (($nbcols-1) - $hidecols) ) {      // Should the column be displayed (not an empty one) ?

                        if ($col > 0) {       // Multiple cols ? Do not forget to add separator
                           echo '        <td width="17" align="center" nowrap="nowrap" valign="middle" style="background-image: url(' .$mosConfig_live_site. '/components/com_jbd/images/separator.png);">';
                           echo '</td>'."\n";
                        }

                        if ( ( $access->canEdit ) || ( $access->canEditOwn ) )
                                                                                    { echo '        <td width="17" nowrap="nowrap">&nbsp;</td>'."\n"; }
                        foreach ($params->columns as $column) {
                           if ($column->name == "icon" && $column->visible )        { echo '        <td width="20" nowrap="nowrap">&nbsp;</td>'."\n"; }
                           if ($column->name == "business" && $column->visible )    { echo '        <td width="';
                                echo ( mosjbdTools::isColVisible('description', $params->columns) && !$params->showdescsplit ) ? floor(45/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                              echo '">&nbsp;</td>'."\n"; }
                           if ($column->name == "description" && $column->visible && !$params->showdescsplit ) { echo '        <td width="';
                              echo ( mosjbdTools::isColVisible ('business', $params->columns) ) ? floor(55/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                              echo '">&nbsp;</td>'."\n"; }
                           if ($column->name == "image" && $column->visible)        { echo '        <td width="60" nowrap="nowrap">&nbsp;</td>'."\n"; }
                           if ($params->canvote && $column->name == "rating" && $column->visible ) {
                              echo '        <td width="';
                              echo ( $params->showratingsplit ) ? '120' : '60';
                              echo '" nowrap="nowrap">&nbsp;</td>'."\n";
                           }
                           if ($column->name == "hits" && $column->visible)         { echo '        <td width="60" nowrap="nowrap">&nbsp;</td>'."\n"; }
                           if ($column->name == "created" && $column->visible)         { echo '        <td width="60" nowrap="nowrap">&nbsp;</td>'."\n"; }
                           if ($column->name == "created_by" && $column->visible)    { echo '        <td width="60" nowrap="nowrap">&nbsp;</td>'."\n"; }

                           if ($column->custom == 1 && $column->visible && ( $column->f_type != 8 || ($column->f_type == 8 && $params->canvote) ) ) {
                              $name = 'f_'.$column->name;
                              if ($column->f_type == 8) {
                                 echo '        <td width="';
                                 switch ($params->showratingsplit) {
                                   case "1" :
                                       echo '100';     // for stars above the vote button
                                       break;
                                   case "2" :
                                       echo '60';      // for elements on 3 lines
                                       break;
                                   case "0" :
                                   default :
                                       echo '160';     // for the all elements on the same line
                                 }
                                 echo '" align="center" nowrap="nowrap">';
                              } else {
                                 echo '        <td width="60" align="left" nowrap="nowrap">';
                              }
                              echo '&nbsp;</td>'."\n";
                           }

                        }
                        if ( !mosjbdTools::isColVisible('business', $params->columns)
                             && (!mosjbdTools::isColVisible('description', $params->columns) || ( mosjbdTools::isColVisible('description', $params->columns) && $params->showdescsplit) )
                             && !mosjbdTools::isColVisible('image', $params->columns)
                           ) {
                           echo '        <td width="'.floor(100/($nbcols-$hidecols)).'%" align="left" nowrap="nowrap">&nbsp;</td>'."\n";
                        }

                     }
                  }

              }

              echo '      </tr>'."\n";         // Close Row Tag


              // *** Display Description on 2nd line
              if ( mosjbdTools::isColVisible('description', $params->columns) && $params->showdescsplit == 2 ) {
                 echo '      <tr class="' .$tabclass[$alternate]. '">'."\n";

                 for ($col=0; $col <= (($nbcols-1) - $hidecols); $col++) {


                     $item = ($col*$nbrows) + $line;                      // Compute grid position

                     if ( $item < $items ) {
                        $row = $rows[$blocks[$block]->first+$item];       // Display item within block at correct grid position
                     } else {
                         unset($row);
                     }

                     if ($col > 0) {       // Multiple cols ? Do not forget to add separator
                        echo '        <td width="17" align="center" nowrap="nowrap" valign="middle" style="background-image: url(' .$mosConfig_live_site. '/components/com_jbd/images/separator.png);">';
                        echo '</td>'."\n";
                     }

                     // Edit icon column
                     if ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) ) {
                        echo '        <td';
                          if ($item < $items && $row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($item < $items && $row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' width="17" >';
                        echo '&nbsp;</td>'."\n";
                     }

                     // *** Column : Description on a separate line... (ShowDescSplit = 1)
                     echo '        <td';
                          if ($item < $items && $row->ratingadmin == 2) {         // Gold
                            echo mosjbdTools::cssClass($params->cssjbdgold);
                          } elseif ($item < $items && $row->ratingadmin == 1) {
                            echo mosjbdTools::cssClass($params->cssjbdbronze);
                          }
                          echo ' colspan="'.$nbcol.'"';
                     echo ' width="';
                     echo ( mosjbdTools::isColVisible('description', $params->columns) && $params->showdescsplit ) ? floor(55/($nbcols-$hidecols))."%" : floor(100/($nbcols-$hidecols))."%";
                     echo '"';
                     echo ' align="left" valign="top">';

                     if ( $item < $items ) {
                        if ( $params->botsonbmdesc && mosjbdTools::isColVisible ('description', $params->columns) && trim(strip_tags($row->description)) ) {
                           // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
                           $row->text = $row->description;  // MosBot only uses field "text" => Need to copy "detail" content ...
                           $row->images = "";               // MosBot Need to simulate "images" field (must be present, but keep empty)
                           $row->sectionid = "";            // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                           $page = 0;                       // MosBot pagination system
                           // Process the MosBots
                           $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                           $row->description = $row->text;   // Return Converted text...
                        }

                        if ($row->description) {
                           echo $row->description;
                        } else {
                           echo '&nbsp;';
                        }
                     } else {
                        echo '&nbsp;';
                     }

                     echo '</td>'."\n";

                 }

                 echo '      </tr>'."\n";  // Close Description row tag (2nd line)
              }

              // *** Display jbd Separator (3rd line)
              if ( $params->showseparator ) {
                 echo '      <tr class="' .$tabclass[$alternate]. '">'."\n";

                 // *** Column : Description on a separate line... (ShowDescSplit = 1)
                 if ( ( $access->canEdit ) || ( $access->canEditOwn ) || ( $params->regcaneditown && $my->id ) ) {
                    $nc = $nbcol+1;
                 } else {
                    $nc = $nbcol;
                 }

                 for ($col=0; $col <= (($nbcols-1) - $hidecols); $col++) {

                     if ($col > 0) {       // Multiple cols ? Do not forget to add separator
                        echo '        <td width="17" align="center" nowrap="nowrap" valign="middle" style="background-image: url(' .$mosConfig_live_site. '/components/com_jbd/images/separator.png);">';
                        echo '</td>'."\n";
                     }

                     echo '        <td colspan="'.$nc.'">';
                     echo '<hr />';
                     echo '</td>'."\n";

                 }

                 echo '      </tr>'."\n";  // Close Separator row tag (3rd line)
              }


              if ($params->showalternate) {  // Alternate Color mode ON ?
                 $alternate = 1 - $alternate;  // Alternate row color
              }

            }  //  end Rows Loop

            echo '    </table>'."\n";

            echo '  </td></tr>'."\n";

            if ($params->showcatdesc == 1 || ( $params->showcatdesc == 2 && $params->mode == 0 ) || ( $params->showcatdesc == 3 && $params->mode == 2 ) ) {
               if ($params->showcatdescpos == 1) {
                 HTML_jbd::DisplayCatImageDesc($option, $Itemid, $bmcat, $params, $blocks);
               }
            }

          } // end any Rows to display ?

       } // end groups

  } else {  // Empty list => Nothing to display...
     if ($params->shownoitem == 1 || ( $params->shownoitem == 2 && $catid > -1 ) ) {

        if ($params->shownoitemtitle) {
           echo '<!-- Search BackTo Index -->'."\n";
           if ($params->mode == 0) {
              $trow = $currentcat;       // User Current Cat as Cat Block
              $bmcat->id = $trow->id;
              $bmcat->cat = $trow->name;
              $bmcat->description = $trow->description;
              $bmcat->image = $trow->image;
              $bmcat->image_position = $trow->image_position;
              $bmcat->icon = $trow->icon;
              HTML_jbd::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks );
           }

           echo '  <tr><td>'."\n";
           echo '    <table class="contentpane" width="100%" border="0" cellspacing="0" cellpadding="1">'."\n";
           HTML_jbd::displayHeader ($option, $Itemid, $catid, $nbcols, $hidecols, $nbcol, $orderbycol, $orderbyupdown, $params, $access);
           echo '    </table>'."\n";
           echo '  </td></tr>'."\n";
        }

        echo '  <tr><td';
        if ($params->shownoitemtitle) { echo ' colspan="' .$nbcol.'"'; }
        echo '>';
        echo _BMU_NO_ITEM_FOUND;
        echo '</td></tr>'."\n";
     }
  }

  if ( count($rows) > 0 ) {  // Some Item(s) to display...
     switch ($params->mode) {  // Last line  : "Back to Top"
       case "0" :   // One Cat
           HTML_jbd::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks, true );
           break;
       case "1" :   // Alpha Grouped
           HTML_jbd::BackToIndexAlpha ($option, $Itemid, $catid, $params, "", $blocks, true );
           break;
       case "2" :   // Cat Grouped
           HTML_jbd::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks, true );
           break;
       case "3" :   // Cat Grouped
           HTML_jbd::BackToIndexCat ($option, $Itemid, $bmcat, $params, $blocks, true );
           break;
       default :    // Other
           break;
     }
  }

  if (($params->submitpos == 0 && ($params->cansubmit && $my->id >= $params->submitlevel) ) || ($params->catpos == 0 && $categories && $params->showcats) ) {
     echo '  <tr><td>&nbsp;</td></tr>'."\n";
  }

  // *** Show Navigator on BOTTOM
  echo '<!-- Navigator (Bottom) -->'."\n";
  if ($params->navigatorpos == '2' || $params->navigatorpos == '3') {
        HTML_jbd::ShowNavigator($option, $Itemid, $catid, $params);
//     echo '  <tr><td>&nbsp;</td></tr>'."\n";
  }


  // *** Show Submit New on BOTTOM
  echo '<!-- Submit New (Bottom) -->'."\n";
  if ($params->submitpos == '0') {
        HTML_jbd::ShowSubmit($option, $Itemid, $catid, $params);
  }

  // *** Show Categories on BOTTOM
  echo '<!-- Categories (Bottom) -->'."\n";
  if ($params->catpos == '0' && $params->mode == 0 && $params->showcats) {
     switch ($params->catdisplayorder) {
       case "1" :
           HTML_jbd::ShowCatsHoriz($option, $catid, $categories, $Itemid, $params);
           break;
       case "2" :
           HTML_jbd::ShowCatsTree($option, $catid, $categories, $Itemid, $params);
           break;
       case "0" :
       default :
           HTML_jbd::ShowCatsVert($option, $catid, $categories, $Itemid, $params);
     }
//     echo '  <tr><td>&nbsp;</td></tr>'."\n";
  }

  HTML_jbd::_footer();

  if (mosjbdTools::isColVisible('images', $params->columns) && $params->showsnapshoterpic && _BM_ADMIN_SNAPSHOTER_PIC_URL) {
     echo "<tr><td>" . _BM_ADMIN_SNAPSHOTER_PIC_URL . "</td></tr>\n";
  }

  echo '</table>'."\n";

  echo "\n".'<!-- ### END Component : Business Directory (c) www.meesaw.com '.mosjbd::getVersion().' ### -->'."\n\n";

}


/*
*********************
**                 **
**  EDIT business  **
**                 **
*********************
*/

/**
* Writes the edit form for new and existing record
*
* A new record is defined when <var>$row</var> is passed with the <var>id</var>
* property set to 0.
* @param mosbusiness The business object
* @param string The html for the categories select list
* @param string The html for the ordering select list
*/
    function editbusiness( &$row, $option, &$lists, $catid, $Itemid, $mode, $search, $access, $navstart, &$params ) {
       global $mosConfig_live_site, $my, $_MAMBOTS;

    echo "\n".'<!-- ### START Component : Business Directory (c) www.meesaw.com '.mosjbd::getVersion().' ### -->'."\n\n";

       mosMakeHtmlSafe( $row );

       // !!! Need to load the javascript routines if user is a simple visitor...
       // !!! As it is loaded by default only for registred users (normally Core Mambo only allows registered to submit).
       // !!! => Load it only if user is a visitor and he can submit and the WYSIWYG is enabled !
       if ( $my->id == 0 && ($params->cansubmit && $params->submitlevel == 0)  ) {
          echo '        <script language="javascript" type="text/javascript" src="' .$mosConfig_live_site. '/includes/js/mambojavascript.js"></script>'."\n";
          if ( $params->descfulledit || $params->detailfulledit ) {
             //  Load Editor for Guest (if not already by template)
             echo "\n".'<!-- ### START Init Editor ### -->'."\n\n";
             initEditor();
             echo "\n".'<!-- ### END Init Editor ### -->'."\n\n";
          }
       }

?>

<?php // if ($params->allowdate || $my->usertype == "Super Administrator") {  // Allow to edit Creation date in front-end - Admins will always be able to do it ?>
        <link rel="stylesheet" type="text/css" media="all" href="<?php echo $mosConfig_live_site;?>/includes/js/calendar/calendar-mos.css" title="green" />
        <!-- import the calendar script -->
        <script type="text/javascript" src="<?php echo $mosConfig_live_site;?>/includes/js/calendar/calendar.js"></script>
        <!-- import the language module -->
        <script type="text/javascript" src="<?php echo $mosConfig_live_site;?>/includes/js/calendar/lang/calendar-en.js"></script>
<?php // } ?>

        <script language="javascript" type="text/javascript">
        function OpenWin(URL) {
           if (URL == '') {
<?php if ($params->checkemptyurl) {  // Check for empty Url ?>
              alert( "<?php echo _BM_business_MUST_HAVE_URL; ?>" );
<?php } ?>
           } else {
              protocols = new Array();
<?php
              $protocols = split( ",", mosjbdTools::getPref(-1,'params','protocols', _BM_PROTOCOLS) );
              // *** List the valid protocols...
              foreach ($protocols as $protocol) {
                 echo '           protocols.push ("' .$protocol. '");'."\n";
              }
?>
              if (URL) {  // if not empty, check for valid protocol
                 prot = false;
                 for (i=0; i<protocols.length; i++) {
                    if ( URL.indexOf(protocols[i]) >= 0 ) {
                       prot = true;
                    }
                 }
                 if ( !prot ) { URL = "http://"+URL; }  // Protocol missing or not in the list => add "http://"
              }

              win  = window.open(URL,"_blank","scrollbars=yes,toolbar=yes,location=yes,directories=yes,status=yes,menubar=yes,resizable=yes");
           }
        }
        </script>

        <script language="javascript" type="text/javascript">
        function submitbutton(pressbutton) {
            var form = document.adminForm;
            if (pressbutton == 'cancel') {
                submitform( pressbutton );
                return;
            }

            // do field validation
            if (form.title.value == ""){
                alert( "<?php echo _BM_business_MUST_HAVE_TITLE; ?>" );
<?php if ($params->checkemptyurl) {  // Check for empty Url ?>
            } else if (form.url.value == ""){
                alert( "<?php echo _BM_business_MUST_HAVE_URL; ?>" );
<?php } ?>
            } else {
<?php if ($params->descfulledit || $my->usertype == "Super Administrator") {  // Allowed to use the full editor to edit the description ?>
               <?php getEditorContents( 'editor1', 'descriptions' ); // Workaround : for FCKeditor that confuse the description field in the Meta tag with the Input field... ?>
<?php } ?>
<?php if ( ($params->detailfulledit && $params->allowdetail) || $my->usertype == "Super Administrator" ) {  // Allow to enter details in front-end - Admins will always be able to enter details ?>
               <?php getEditorContents( 'editor2', 'detail' ); ?>
<?php } ?>

                submitform( pressbutton );
            }
        }
        </script>

<?php     // MosBot : Convert "$params" to "mosParameters" format
     $prms = "";
     $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)
     foreach ($params as $k=>$v) {
        $bmparams->def($k,$v);
     }

     echo '<!-- Component Header -->'."\n";
     if ($params->comheadersubmit && $params->botsonheadersubmit) {         // Field : Header Wrapper
        // *** Init MosBots (loading "Content" related bots)
        // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
        $row->images = "";                      // MosBot Need to simulate "images" field (must be present, but keep empty)
        $page = 0;                              // MosBot pagination system
        $row->sectionid = "";                   // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
        $_MAMBOTS->loadBotGroup( 'content' );   // Load published Bots from "Content" folder
        // *** Process the MosBots
        $row->text = $params->comheadersubmit;  // MosBot only uses field "text" => Need to copy "detail" content ...
        $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
        $params->comheadersubmit= $row->text;
     }

     echo '<div class="contentpane">';
     echo $params->comheadersubmit;
     echo '</div>';


/*
foreach ($row as $k=>$v) {
  echo "DEBUG: $k: $v<br />\n";
  if (substr($k,0,2)=="f_") {
     echo "DEBUG : ... <b>$k</b> ";
     foreach ($v as $x=>$y) {
       echo "| $x: $y ";
     }
     echo "<br />\n";
  }
}
*/

/*
echo "DEBUG: AllowPrivate : ".$params->allowprivate."<br />\n";
echo "DEBUG: ForcePrivate : ".$params->forceprivate."<br />\n";
echo "DEBUG: Private : ".$row->private."<br />\n";
echo "DEBUG: User : ".$my->username."<br />\n";
echo "DEBUG: id : ".$my->id."<br />\n";
echo "DEBUG: gid : ".$my->gid."<br />\n";
echo "DEBUG: usertype : ".$my->usertype."<br />\n";
*/

/*
foreach ($my as $k=>$v) {
  echo "DEBUG: MY : $k: $v<br />\n";
}
*/

/*
foreach ($access as $k=>$v) {
  echo "DEBUG: ACCESS : $k: $v<br />\n";
}
*/

  ?>



        <table cellpadding="4" cellspacing="0" border="0" width="100%">
          <tr>
            <td width="100%"><span class="contentheading"><?php echo $row->id ? _BM_EDIT : _BM_ADD;?> <?php echo _BM_business; ?></span></td>
              <td width="50%">
<?php   // *** Action Buttons
            mosToolBar::startTable();
            mosToolBar::spacer();
            mosToolBar::save();
            mosToolBar::spacer(25);
            mosToolBar::cancel();
            mosToolBar::endtable();
?>
            </td>
          </tr>
        </table>

        <form action="<?php echo "index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search"; ?>" method="post" name="adminForm" id="adminForm">

        <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">

            <tr valign="top">
                <td width="10%" nowarp="nowrap" align="right"><?php echo _BM_NAME; ?>:</td>
                <td width="90%">
                    <input class="inputbox" type="text" name="title" size="50" maxlength="250" value="<?php echo $row->title;?>" />
                </td>
            </tr>
<?php if ( ( $params->submitcat == 0 ) || ( ( $params->submitcat != 0 ) && ( $access->canEdit ) || ( $access->canEditOwn ) || ($my->usertype == "Super Administrator") ) ) {  ?>
            <tr valign="top">
                <td align="right" nowarp="nowrap"><?php echo _BM_CATEGORY; ?>:</td>
                <td>
                    <?php echo $lists->clist; ?><br />
                    <?php echo _BMU_MULTISELECT_HELP; ?><br />
                </td>
            </tr>
<?php } ?>
            <tr valign="top">
                <td align="right" nowarp="nowrap"><?php echo _BM_URL; ?>:</td>
                <td>
                    <table border="0" cellspacing="0" cellpadding="0">
                      <tr valign="top">
                      <td><input class="inputbox" type="text" name="url" value="<?php echo $row->url; ?>" size="50" /></td>
                      <td><img src="<?PHP echo $mosConfig_live_site; ?>/components/com_jbd/images/html.png" hspace="5" title="<?php echo _BMU_TEST_URL; ?>" alt="URL" onclick="OpenWin(document.adminForm.url.value); return false" /></td>
                      </tr>
                    </table>
                </td>
            </tr>

        </table>

        <br />
<?php

       $tabs = new mosTabs(0);
       $tabs->startPane("edit-params");

       if ($params->allowdesc || $params->allowdetail || $my->usertype == "Super Administrator" ) {

          $tabs->startTab(_BM_EDITOR_ADMIN_DESCRIPTION,"Desc-page");
?>

        <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">

<?php if ($params->allowdesc || $my->usertype == "Super Administrator") {  // Allow to enter details in front-end - Admins will always be able to do it ?>

<?php    if ($params->allow_getmeta || $my->usertype == "Super Administrator") {  // Allowed to retrieve MetaTag "Description" - Admins will always be able to do it ?>
            <tr valign="top">
                <td align="right" nowarp="nowrap"><?php echo _BM_GETMETA ?>:</td>
                <td>
                    <?php echo $lists->getmetalist; ?>
                </td>
            </tr>

<?php    } ?>
            <tr valign="top">
                <td width="10%" align="right" nowarp="nowrap"><?php echo _BM_SHORT_DESCRIPTION; ?>:</td>
                <td width="90%">
<?php    if ($params->descfulledit || $my->usertype == "Super Administrator") {  // Allowed to use the full editor to edit the description ?>
                <?php
                // parameters : areaname, content, hidden field, width, height, rows, cols
                editorArea( 'editor1',  $row->description , 'descriptions', $params->desceditwidth, $params->desceditheight, $params->descboxwidth, $params->descboxheight );
                ?>
<?php    } else { ?>
                <textarea name="descriptions" cols="<?php echo $params->descboxwidth; ?>" rows="<?php echo $params->descboxheight; ?>"><?php echo $row->description; ?></textarea>
<?php    } ?>
<?php    if (_BM_SHORT_DESCRIPTION_HELP) { ?>
                <br />
                <?php echo _BM_SHORT_DESCRIPTION_HELP; ?>
<?php    } ?>
                </td>
            </tr>

<?php } ?>
<?php if ($params->allowdetail || $my->usertype == "Super Administrator") {  // Allow to enter details in front-end - Admins will always be able to do it ?>
            <tr valign="top">
                <td align="right" nowarp="nowrap"><?php echo _BM_REDIRECT ?>:</td>
                <td>
                    <?php echo $lists->redirlist; ?>
                </td>
            </tr>

            <tr valign="top">
                <td align="right" nowarp="nowrap"><?php echo _BM_DETAIL; ?>:</td>
                <td>
<?php    if ($params->detailfulledit || $my->usertype == "Super Administrator") {  // Allowed to use the full editor to edit the detail ?>
                <?php
                // parameters : areaname, content, hidden field, width, height, rows, cols
                editorArea( 'editor2',  $row->detail , 'detail', $params->desceditwidth, $params->desceditheight, $params->descboxwidth, $params->descboxheight );
                ?>
<?php    } else { ?>
                <textarea name="detail" cols="<?php echo $params->descboxwidth; ?>" rows="<?php echo $params->descboxheight; ?>"><?php echo $row->description; ?></textarea>
<?php    } ?>
<?php    if (_BM_DETAIL_HELP) { ?>
                <br />
                <?php echo _BM_DETAIL_HELP; ?>
<?php    } ?>
                </td>
            </tr>

<?php } ?>
        </table>

<?php
          $tabs->endTab();

      }

      if ($my->id >= 1 || ($my->id == 0 && $params->allowdate) ) {    // Hide the pane if there are no parameters (Guest will only have the Creation Date)

         $tabs->startTab(_BM_EDITOR_ADMIN_PARAMS,"params-page");
?>

           <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">

<?php if ($my->id) {  // Allow Registred Users to Approve in front-end - Hidden for Guests ?>
               <tr valign="top">
                   <td width="10%" align="right" nowarp="nowrap"><?php echo _BM_APPROVED ?>:</td>
                   <td width="90%">
                       <?php echo $lists->applist; ?>
                   </td>
               </tr>
<?php } ?>
<?php if ($my->usertype == "Super Administrator") {  // Allow Administrators to Publish in front-end  - Hidden for Guests and Registered ?>
               <tr valign="top">
                   <td width="10%" align="right" nowarp="nowrap"><?php echo _BM_PUBLISHED ?>:</td>
                   <td width="90%">
                       <?php echo $lists->publist; ?>
                   </td>
               </tr>
<?php } ?>
<?php if ( ( $my->id && $params->allowprivate && !$params->forceprivate ) || $my->usertype == "Super Administrator" ) {  // Allow Registered (registered=1) to keep business Private in front-end - Hidden for Guests ?>
               <tr valign="top">
                   <td width="10%" align="right" nowarp="nowrap"><?php echo _BM_PRIVATE ?>:</td>
                   <td width="90%">
                       <?php echo $lists->privlist; ?>&nbsp;&nbsp;<b><?php echo $row->username; ?></b>
                   </td>
               </tr>
<?php } ?>
<?php if ($params->allowdate || $my->usertype == "Super Administrator") {  // Allow to edit Creation date in front-end - Admins will always be able to do it ?>
               <tr valign="top">
                   <td width="10%" align="right" nowarp="nowrap"><?php echo _BM_CREATION_DATE; ?>:</td>
                   <td width="90%">
                      <input class="inputbox" type="text" name="created" id="created" size="25" maxlength="19" value="<?php echo $row->created; ?>" />
                      <input type="reset" class="button" value="..." onclick="return showCalendar('created', 'y-mm-dd');" />
                   </td>
               </tr>
<?php } ?>
<?php if ($my->usertype == "Super Administrator") {  // Allow to edit the Admin Rating (Std, Bronze or Gold) - Only for Admins ! ?>
               <tr valign="top">
                   <td width="10%" align="right" nowarp="nowrap"><?php echo _BM_ADMIN_RATING; ?>:</td>
                   <td width="90%">
                    <?php echo $lists->ratingadm; ?>
                   </td>
               </tr>
<?php } ?>
<?php if ($my->usertype == "Super Administrator") {  // Allow to edit the Validation Method (Automatic or Manual) - Only for Admins ! ?>
            <tr valign="top">
                <td align="right" nowarp="nowrap"><?php echo _BM_VALIDATION; ?>:</td>
                <td>
                   <?php echo $lists->validlist; ?>
                </td>
            </tr>
<?php } ?>


           </table>

<?php
         $tabs->endTab();

      }

      // *** Check if there are some Custom Fields to display, if none hide the pane...
      $isCustomFields = false;
      foreach ($row as $name=>$obj) {
         if (substr($name,0,2)=='f_' && $obj->visibleedit && $obj->f_type != 8) { // is custom field, visible in editor and Not Rating type ?
            $isCustomFields = true;
         }
      }

      if ($isCustomFields) {

         $tabs->startTab(_BM_EDITOR_ADMIN_CUSTOM,"custom-page");

?>

           <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">

<?php
                 // *** Display Custom Fields
                 foreach ($row as $name=>$obj) {
                    if (substr($name,0,2)=='f_' && $obj->visibleedit && $obj->f_type != 8) {
                       echo '           <tr valign="top">';
                       echo '<td width="10%" align="right" nowarp="nowrap">';
                       echo $obj->title.':';
                       echo '</td>';
                       echo '<td width="90%">';
                       echo $lists->$name;
                       echo '</td>';
                       echo '</tr>'."\n";
                    }
                 }
?>

           </table>

<?php
         $tabs->endTab();
      }

      $tabs->endPane();
?>

<?php if (!$params->allow_getmeta) {  // Allowed to retrieve MetaTag "Description" ?>
        <input type="hidden" name="allow_getmeta" value="0" />
<?php } ?>

        <input type="hidden" name="option" value="<?php echo $option;?>" />
        <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
        <input type="hidden" name="catid" value="<?php echo $catid; ?>" />
        <input type="hidden" name="Itemid" value="<?php echo $Itemid; ?>" />
        <input type="hidden" name="task" value="" />
        </form>

        <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">
<?php
        HTML_jbd::_footer(2);
?>
        </table>

<?php

    echo "\n".'<!-- ### END Component : Business Directory (c) www.meesaw.com '.mosjbd::getVersion().' ### -->'."\n\n";

    }


// ************************
// *** SHOW DETAIL PAGE ***
// ************************

function detailbusiness (&$row, $option, &$lists, $catid, $Itemid, $mode, $search, $access, &$params) {
  global $database, $my, $mosConfig_live_site;
  global $_MAMBOTS;

  echo "\n".'<!-- ### START Component : Business Directory (c) www.meesaw.com '.mosjbd::getVersion().' ### -->'."\n\n";

  $params->_Itemid = $Itemid;
  $params->_option = $option;
  $params->_catid = $catid;
  $params->search = $search;
  $params->mode = $mode;

/*
foreach ($params as $k=>$v) {
  echo "DEBUG: $k: $v<br />\n";
}
echo "DEBUG: 2 catid : ".$catid."<br />\n";
*/


  // MosBot : Convert "$params" to "mosParameters" format
  $prms = "";
  $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)
  foreach ($params as $k=>$v) {
     $bmparams->def($k,$v);
  }

  // *** Prepare Image url (compute link)
  if (!(eregi("^http://", $row->imageurl) || (eregi("^https://",$row->imageurl)))) {
     $picurl = $mosConfig_live_site. '/images/stories/' .$row->imageurl;    // Internal image from Images/Stories
  } else {
     $picurl = $row->imageurl;                                              // External image (use url)
     if ( eregi($params->urlkey, $picurl) ) {                               // is the URL Keyword present ?
        $picurl = str_replace($params->urlkey, $row->url, $picurl);         // replace the "URL Keyword" with the URL...
     }
  }

  // *** Build URL according to Redirection and OpenWin
  if ($row->url != "") {
    if ($params->directurl) {                 // Use direct URL => Not Hits Count !!!!
       $anchor = '<a href="' .$row->url. '"';
    } else {
       if ($row->openwin == 2) {              // Open url in Wrapper
          $anchor = '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=wrapper&id=".$row->id). '"';
       } else {
          $anchor = '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=view&id=".$row->id). '"';
       }
    }
    if ($row->openwin == 1) {                 // Open url in a blank page
       $anchor .= ' target="_blank"';
    }
    if ($row->openwin == 0) {                 // Open url in the parent page
       $anchor .= ' target="_parent"';
    }
    $anchor .= mosjbdTools::cssClass($params->cssjbd);
    $anchor .= '>';
    $anchorend = '</a>';
  } else {                                    // No URL => No redirection...
    if ($params->emptyurlnolink) {
      $anchor = '<span '.mosjbdTools::cssClass($params->cssjbd).'>';
      $anchorend = '</span>';
    } else {
      $anchor = '<a href="javascript:void(0);"'.mosjbdTools::cssClass($params->cssjbd).'>';
      $anchorend = '</a>';
    }
  }

  // *** Init MosBots (loading "Content" related bots)
  if ( ($params->comheaderdetail && $params->botsonheaderdetail) || ($params->pagedescdetail && $params->botsonpagedescdetail) || $params->botsonbmdetail || $params->botsonbmdesc || $params->botsondetailads ) {
     // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
     $row->images = "";                      // MosBot Need to simulate "images" field (must be present, but keep empty)
     $row->sectionid = "";                   // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
     $page = 0;                              // MosBot pagination system
     $_MAMBOTS->loadBotGroup( 'content' );   // Load published Bots from "Content" folder
  }

  echo '<table cellpadding="2" cellspacing="0" border="0" width="100%" class="adminform">'."\n";
  echo '<tr valign="top">';
  echo '<td';
  //if ( trim(strip_tags($params->detailads)) ) {
  if ( $params->detailads ) {
     echo ' colspan="2"';
  }
  echo '>';

  echo '<!-- Page Title -->'."\n";
  if ($params->detailshowpagetitle) {
     echo (_BMU_business_DETAIL) ? '<div class="componentheading">'._BMU_business_DETAIL.'<br /></div>'."\n" : "";
  }

  echo '<!-- Component Header -->'."\n";
  if ($params->comheaderdetail) {
     if ($params->botsonheaderdetail) {         // Field : Header Detail
        // *** Process the MosBots
        $row->text = $params->comheaderdetail;  // MosBot only uses field "text" => Need to copy "detail" content ...
        $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
        $params->comheaderdetail = $row->text;
     }
     echo '<div class="contentpane">';
     echo $params->comheaderdetail;
     echo '</div>';
  }

  // *** Process the MosBots, only if set to be performed !
  if ($params->botsonbmdetail) {            // Field : Detail
     $row->text = $row->detail;             // MosBot only uses field "text" => Need to copy "detail" content ...
     $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
     $row->detail = $row->text;            // Return converted text
  }

  if ($params->botsonbmdesc) {              // Field : Description
     $row->text = $row->description;        // MosBot only uses field "text" => Need to copy "detail" content ...
     $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
     $row->description = $row->text;        // Return converted text
  }

  if ($params->botsondetailads) {           // Field : Description
     $row->text = $params->detailads;       // MosBot only uses field "text" => Need to copy "detail" content ...
     $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
     $params->detailads = $row->text;       // Return converted text
  }

  echo '<!-- jbd Popup Script -->'."\n";
  mosjbdTools::bm_popup($params);   // Load jbd popup script

  echo '<!-- Custom Field Popup Script -->'."\n";
  mosjbdTools::f_popup($params);   // Load Custom Fields popup script

  echo '</td></tr>';

  echo '<!-- Page Detail -->'."\n";
  echo '<tr valign="top">';
  echo '<td>';
  echo '<table cellpadding="2" cellspacing="0" border="0" width="100%" class="adminform">'."\n";

  if ($params->detailshowtitles) { // Force size of the first column
     echo '  <tr>';
     echo '<td width="100"></td>';
     echo '<td></td>';
     echo '</tr>'."\n";
  }

  if (mosjbdTools::isColVisible( 'business', $params->columns, 'detail' )) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_URL. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'."\n";
     echo '<span class="contentheading">'."\n";

     if ( mosjbdTools::isColVisible( 'icon', $params->columns, 'detail' ) ) {
        echo $anchor;
        echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/html.png" border="0" alt="" />';
        echo $anchorend."\n";
     }
     echo $anchor;
     echo $row->title;
     echo $anchorend."\n";
     echo '</span>'."\n";

     if ($params->canrecommend && $my->id) {
        echo '<a href="'. sefRelToAbs("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&task=recommendd&mode=".$params->mode."&id=".$row->id."&search=".$params->search). '">';
        echo '<img src="' .$mosConfig_live_site. '/images/M_images/emailButton.png" border="0" alt="' ._BMU_RECOMMEND. '" title="'._BMU_RECOMMEND.'" />';
        echo '</a>&nbsp;';
     }

     // *** Admin Rating
     if ($row->ratingadmin) {
        if ($row->ratingadmin == 1) {   // Bronze
           echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/isbronze.png" border="0" alt="' ._BMU_ISBRONZE. '" title="'._BMU_ISBRONZE.'" />&nbsp;';
        } else {                        // Gold
           echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/isgold.png" border="0" alt="' ._BMU_ISGOLD. '" title="'._BMU_ISGOLD.'" />&nbsp;';
        }
     }

     // *** Popularity : New
     if ($params->showpoplast) {
        $created = mosjbdTools::calcElapsedDays( $row->created );
        if ($created->days <= $params->showpoplast) {
           echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/isnew.png" border="0" alt="' ._BMU_ISNEW. '" title="'._BMU_ISNEW.' ('.$created->days.' '._BM_DAYS.')" />&nbsp;';
        }
     }

     // *** Popularity : Top Rated
     if ($params->showpoptop && $params->canvote) {
        if ($row->rating >= $params->showpoptop) {
           echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/istop.png" border="0" alt="' ._BMU_ISTOP. '" title="'._BMU_ISTOP.' ('.$row->rating.')" />&nbsp;';
        }
     }

     // *** Popularity : Best Hits
     if ($params->showpopbest) {
        if ($row->hits >= $params->showpopbest) {
           echo '<img src="' .$mosConfig_live_site. '/components/com_jbd/images/isbest.png" border="0" alt="' ._BMU_ISBEST. '" title="'._BMU_ISBEST.' ('.$row->hits.')" />&nbsp;';
        }
     }

     // *** Edit Item
     if ( $access->canEdit || ( $access->canEditOwn && $row->created_by == $my->id) || $my->usertype == "Super Administrator" ) {
        echo '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=edit&catid=$catid&navstart=".$params->navstart."&mode=".$params->displaymode."&id=".$row->id."&search=".$params->defaultsearch). '" title="' ._E_EDIT. ' : ' .htmlspecialchars($row->title, ENT_NOQUOTES). '">';
        echo '<img src="' .$mosConfig_live_site. '/images/M_images/edit.png" border="0" alt="' ._E_EDIT. '" />';
        echo '</a>';
     }

     echo '  </td>';
     echo '</tr>'."\n";
  }

  if ( mosjbdTools::isColVisible( 'image', $params->columns, 'detail' ) && $row->imageurl) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_IMAGE. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>';
     echo $anchor;
     echo '<img src="' .$picurl. '"';
     if ($params->imgforcedetailwidth) {
        echo ' width="' .$params->imgforcedetailwidth. '"';    // To force the image size...
     }
     if ($params->imgforcedetailheight) {
        echo ' height="' .$params->imgforcedetailheight. '"';    // To force the image size...
     }
     echo ' border="0" align="left" alt=""';
// !!pic2
//     echo ' onload="if (this.width<5) {this.src=\'/images/stories/noimage.png\'; this.width=\'120\'; this.height=\'90\'}"';      // Thumbshort trick to resize empty (1x1) image...
     echo ' />';
     echo $anchorend;
     echo '</td>';
     echo '</tr>'."\n";
  }

  if ( mosjbdTools::isColVisible( 'description', $params->columns, 'detail' ) && trim(strip_tags($row->description))) {
     echo '    <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_SHORT_DESCRIPTION. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. $row->description. '</td>';
     echo '</tr>'."\n";
  }

  if (mosjbdTools::isColVisible( 'detail', $params->columns, 'detail' ) && trim(strip_tags($row->detail))) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
           echo '<td nowrap="nowrap"><b>'. _BMU_DETAIL. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. $row->detail. '</td>';
     echo '</tr>'."\n";
  }

  if (mosjbdTools::isColVisible( 'category', $params->columns, 'detail' )) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_CAT. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>';
     if (!$row->categories) {
        echo $row->category;
     } else {
        echo "\n".'<ul>'."\n";
        foreach ($row->categories as $catn) {
           echo '    <li>'.htmlspecialchars($catn, ENT_NOQUOTES)."</li>"."\n";
        }
        echo '</ul>'."\n";
     }
     echo '  </td>';
     echo '</tr>'."\n";
  }

  if (mosjbdTools::isColVisible( 'rating', $params->columns, 'detail' ) && $params->canvote) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_RATING. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>';

     // ** retrieve column "Rating"
     $column = array();
     for ($i=0; $i<count($params->columns); $i++) {
       $col = &$params->columns[$i];
       if ( $col->name == 'rating' ) {
         $column = $col;
       }
     }

     if ( ($params->canvotedetail == 1 || $params->canvotedetail == 2) && $my->gid >= $params->votelevel) {
        echo mosjbdTools::displayRating ('rating', $row, $column, $params, true, 3, $lists->rating);
     } else {
        echo mosjbdTools::displayRating ('rating', $row, $column, $params, true, 2);
     }

     echo '</td>';
     echo '</tr>';
  }

  if (mosjbdTools::isColVisible( 'hits', $params->columns, 'detail' )) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_HITS. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. number_format($row->hits, 0, _BMU_FMT_DECIMAL, _BMU_FMT_THOUSAND). '</td>';
     echo '</tr>';
  }

  if (mosjbdTools::isColVisible( 'created', $params->columns, 'detail' )) {
     echo '    <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_DATE. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. mosFormatDate($row->created). ' / '. mosFormatDate($row->modified). '</td>';
     echo '</tr>';
  }

  if (mosjbdTools::isColVisible( 'created_by', $params->columns, 'detail' )) {
     echo '  <tr valign="top">';
     if ($params->detailshowtitles) {
        echo '<td nowrap="nowrap"><b>'. _BMU_PUBLISHER. '</b>&nbsp;:&nbsp;</td>';
     }
     echo '<td>'. $row->username. '';
     if ($row->private && $params->markprivate && $params->allowprivate) {
        echo '&nbsp;<span style="color: Red; font-weight: bold;" title="' ._BMU_PRIVATE. ' : '.$row->username.'">'._BMU_PRIVATE_MARK.'</span>&nbsp;';
     }
     echo '</td>';
     echo '</tr>'."\n";
  }

  // Custom fields
  foreach ($params->columns as $column) {


    if ($column->custom) {
       $name = 'f_'.$column->name;
       if (mosjbdTools::isColVisible( $name, $params->columns, 'detail' )) {
          if ( ($row->$name && $column->f_type != 8) || ($params->canvote && $column->f_type == 8) || $column->f_type == 4 ) {
             echo '  <tr valign="top">';
             if ($params->detailshowtitles) {
                echo '<td nowrap="nowrap"><b>'. $column->title. '</b>&nbsp;:&nbsp;</td>';
             }
             echo '<td>';
             if (($params->canvotedetail == 1 || $params->canvotedetail == 2) && $my->gid >= $params->votelevel && $column->f_type == 8) {  // RATE type & User can vote in Detail page
                echo mosjbdTools::displayCustom ($name, $row, $column, $params, true, 3, $lists->$name);
             } else {
                echo mosjbdTools::displayCustom ($name, $row, $column, $params, true, 2);
             }

             echo '</td>';
             echo '</tr>'."\n";
          }
       }
    }
  }

echo '</table>'."\n";
echo '</td>'."\n";

//if ( trim(strip_tags($params->detailads)) ) {
if ( $params->detailads ) {
   echo '<td '.mosjbdTools::cssClass($params->cssdetailads).' width="' .$params->detailadswidth. '" nowarp="nowrap">';
   echo $params->detailads;
   echo '</td>';
}

echo '</tr>'."\n";
echo '</table>'."\n";

?>
<table cellpadding="0" cellspacing="0" border="0" width="100%" class="adminform">

    <!-- Back Button -->
    <tr>
      <td align="center">
         <br />
         <span class="back_button"><a href="<?php echo sefRelToAbs("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&mode=".$mode."&search=".$search); ?>"><b><?php echo _BACK; ?></b></a></span>
      </td>
    </tr>

<?php
    HTML_jbd::_footer();

    echo '</table>'."\n";

    echo "\n".'<!-- ### END Component : Business Directory (c) www.meesaw.com '.mosjbd::getVersion().' ### -->'."\n\n";

    }


// ************************
// ***   OPEN WRAPPER   ***
// ************************

/**
* Open Link in a wrapper
*
* A new record is defined when <var>$row</var> is passed with the <var>id</var>
* property set to 0.
* @param mosbusiness The business object
* @param string The html for the categories select list
* @param string The html for the ordering select list
*/
   function wrapperbusiness ( &$row, $option, &$lists, $catid, $Itemid, $mode, $search, $access, $navstart, &$params ) {
       global $mosConfig_live_site, $my;
       global $_MAMBOTS;

       echo "\n".'<!-- ### START Component : Business Directory (c) www.meesaw.com '.mosjbd::getVersion().' ### -->'."\n\n";

       // MosBot : Convert "$params" to "mosParameters" format
       $prms = "";
       $bmparams =& new mosParameters( $prms );   // Use "$botparms" to avoid overwritting "$params" (from Module)
       foreach ($params as $k=>$v) {
          $bmparams->def($k,$v);
       }
?>

        <table cellpadding="4" cellspacing="0" border="0" width="100%">

          <!-- Page Title -->
          <tr><td width="100%"><span class="contentheading"><?php echo _BMU_business; ?> : <?php echo $row->title ?></span></td></tr>

<?php
          echo '          <!-- Component Header -->'."\n";
          if ($params->comheaderwrapper) {
             if ($params->comheaderwrapper && $params->botsonheaderwrapper) {
                // *** Init MosBots (loading "Content" related bots)
                // *** MosBot : The {MosImage} is no supported as the Images field is not present !!! => Need to use fixed path for images...
                $row->images = "";                      // MosBot Need to simulate "images" field (must be present, but keep empty)
                $row->sectionid = "";                   // MosBot Need to simulate "sectionid" field (must be present, but keep it empty)
                $page = 0;                              // MosBot pagination system
                $_MAMBOTS->loadBotGroup( 'content' );   // Load published Bots from "Content" folder
                // *** Process the MosBots
                $row->text = $params->comheaderwrapper;  // MosBot only uses field "text" => Need to copy "detail" content ...
                $results = $_MAMBOTS->trigger( 'onPrepareContent', array( &$row, &$bmparams, $page ), true );
                $params->comheaderwrapper = $row->text;
             }
             echo '          <tr><td><div class="contentpane">';
             echo $params->comheaderwrapper;
             echo '</td></tr></div>'."\n";
          }
?>

          <!-- Back Button -->
          <tr><td align="center"><span class="back_button"><a href="javascript:window.history.go(-1);"><b><?php echo _BACK; ?></b></a></span><br /></td></tr>

          <!-- Open Wrapper -->
          <tr style="height: <?php echo $params->wrapperheight; ?>px">
            <td>
               <iframe src="<?php echo $row->url; ?>" width="<?php echo $params->wrapperwidth; ?>" height="<?php echo $params->wrapperheight; ?>" scrolling="AUTO" border="1" marginwidth="2"></iframe>
            </td>
          </tr>

          <!-- Back Button -->
          <tr><td align="center"><span class="back_button"><a href="javascript:window.history.go(-1);"><b><?php echo _BACK; ?></b></a></span><br /></td></tr>

<?php
        HTML_jbd::_footer(2);
?>
        </table>

<?php

    echo "\n".'<!-- ### END Component : Business Directory (c) www.meesaw.com '.mosjbd::getVersion().' ### -->'."\n\n";

    }



// ************************
// *** RECOMMEND LINK   ***
// ************************

/**
* Recommend link to a Friend => Ask for Contact information to be able to send the URL
*
* A new record is defined when <var>$row</var> is passed with the <var>id</var>
* property set to 0.
* @param mosbusiness The business object
* @param string The html for the categories select list
* @param string The html for the ordering select list
*/
   function recommendbusiness ( &$row, $option, &$lists, $catid, $Itemid, $mode, $search, $access, $navstart, &$params ) {
       global $mosConfig_live_site, $my, $_MAMBOTS;

       echo "\n".'<!-- ### START Component : Business Directory (c) www.meesaw.com '.mosjbd::getVersion().' ### -->'."\n\n";

       mosMakeHtmlSafe( $row );
?>

        <script language="javascript" type="text/javascript">
        function submitbutton(pressbutton) {
            var form = document.adminForm;

            if (pressbutton == 'cancel') {
                submitform( pressbutton );
                return;
            }

            // *** validate mail address
            var mail = form.mailaddress.value;
            var pattern=/^[a-zA-Z0-9_\-.]+@[a-zA-Z0-9\-]{2,}[.][a-zA-Z]{2,3}$/;
            valid = pattern.test(mail);

            // *** Do fields validation
            if (!valid){  // mail format not valid...
                alert( "<?php echo _BM_CONTACT_MUST_HAVE_ADDRESS; ?>" );
            } else {

                submitform( pressbutton );
            }
        }
        </script>

        <table cellpadding="4" cellspacing="0" border="0" width="100%">
          <tr>
            <!-- Page Title -->
            <td width="100%"><span class="contentheading"><?php echo _BM_RECOMMEND_TO_FRIEND; ?></span></td>
          </tr>

            <!-- Actions -->
          <tr>
              <td width="50%">
<?php   // *** Action Buttons
            mosToolBar::startTable();
            mosToolBar::spacer();
            if ($params->returntask == 'detail') {
               mosToolBar::custom( 'sendd', '../components/com_jbd/images/send.png', '../components/com_jbd/images/send_f2.png', 'Send Mail', false);
            } else {
               mosToolBar::custom( 'send', '../components/com_jbd/images/send.png', '../components/com_jbd/images/send_f2.png', 'Send Mail', false);
            }
            mosToolBar::spacer(25);
            mosToolBar::cancel();
            mosToolBar::endtable();
?>
            </td>
          </tr>
        </table>

        <!-- Form -->
        <form action="<?php echo "index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search"; ?>" method="post" name="adminForm" id="adminForm">

        <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">

            <tr valign="top">
                <td width="100" nowarp="nowrap" align="right"><?php echo _BM_TITLE; ?>:</td>
                <td>
                    <?php echo $row->title; ?>
                </td>
            </tr>
            <tr valign="top">
                <td nowarp="nowrap" align="right"><?php echo _BM_URL; ?>:</td>
                <td>
                    <?php echo $row->url; ?>
                </td>
            </tr>

            <tr valign="top">
                <td nowarp="nowrap" align="right"><?php echo _BMU_MAIL; ?>:</td>
                <td>
                    <input class="inputbox" type="text" id="mailaddress" name="mailaddress" value="" size="50" maxlength="100" />
                </td>
            </tr>

            <tr valign="top">
                <td nowarp="nowrap" align="right"><?php echo _BMU_COMMENT; ?>:</td>
                <td>
                    <textarea id="mailcomment" name="mailcomment" cols="25" rows="5"></textarea>
                </td>
            </tr>

        </table>

       <table cellpadding="0" cellspacing="0" border="0" width="100%" class="adminform">

           <!-- Back Button -->
           <tr>
             <td align="center">
                <br />
<?php
                $link = "index.php?option=$option&Itemid=$Itemid";
                $link .= ($params->returntask=='detail') ? '&task=detail&id='.$row->id : '';
                $link .= "&catid=$catid&navstart=".$params->navstart."&mode=".$mode."&search=".$search;
?>
                <span class="back_button"><a href="<?php echo sefRelToAbs($link); ?>"><b><?php echo _BACK; ?></b></a></span>
             </td>
           </tr>

        </table>

        <input type="hidden" name="option" value="<?php echo $option;?>" />
        <input type="hidden" name="id" value="<?php echo $row->id; ?>" />
        <input type="hidden" name="catid" value="<?php echo $catid; ?>" />
        <input type="hidden" name="Itemid" value="<?php echo $Itemid; ?>" />
        <input type="hidden" name="task" value="" />
      </form>

      <table cellpadding="4" cellspacing="0" border="0" width="100%" class="adminform">
<?php
      HTML_jbd::_footer(2);
?>
      </table>

<?php

    echo "\n".'<!-- ### END Component : Business Directory (c) www.meesaw.com based on Bookmarks by TEGdesign '.mosjbd::getVersion().' ### -->'."\n\n";

    }



} // end class
?>