<?php

defined( '_VALID_MOS' ) or die( 'Direct Access to this location is not allowed.' );

require_once( $mainframe->getPath( 'front_html' ) );
require_once( $mainframe->getPath( 'class' ) );

// *** Get language files
if (file_exists($mosConfig_absolute_path.'/components/com_jbd/language/' . $mosConfig_lang . '.php')) {
   include_once($mosConfig_absolute_path.'/components/com_jbd/language/' . $mosConfig_lang . '.php');
} else {
   include_once($mosConfig_absolute_path.'/components/com_jbd/language/english.php');
}

// Editor usertype check
$access = new stdClass();
$access->canEdit = $acl->acl_check( 'action', 'edit', 'users', strtolower($my->usertype), 'content', 'all' );
$access->canEditOwn = $acl->acl_check( 'action', 'edit', 'users', strtolower($my->usertype), 'content', 'own' );
$access->canPublish = $acl->acl_check( 'action', 'add', 'users', strtolower($my->usertype), 'content', 'all' );

$option = trim( strtolower( mosGetParam( $_REQUEST, 'option', 'com_jbd' ) ) );
$task = trim( mosGetParam( $_POST, 'task', "" ) );
if ($task == "") { $task = trim( mosGetParam( $_REQUEST, 'task', "" ) ); }
$mode = intval( mosGetParam( $_REQUEST, 'mode', mosjbdTools::getPref(-1,'params','displaymode', '0') ) );
$catid = intval( mosGetParam( $_REQUEST, 'catid', 0 ) );
$id = intval( mosGetParam( $_REQUEST, 'id', 0 ) );
$search = trim( strtolower( mosGetParam( $_POST, 'search', '' ) ) );
if ($search == "") { $search = trim( strtolower( mosGetParam( $_REQUEST, 'search', '' ) ) ); }
$orderbycol = trim( strtolower( mosGetParam( $_REQUEST, 'orderbycol', 'title' ) ) );
$orderbyupdown = trim( strtolower( mosGetParam( $_REQUEST, 'orderbyupdown', 'asc') ) );
$message = trim( strtolower( mosGetParam( $_REQUEST, 'msg', '' ) ) );
$navstart = intval( mosGetParam( $_REQUEST, 'navstart', 0 ) );

if (substr($task,0,4) == 'vote' || substr($task,0,4) == 'votd') {  // Retrieve user's vote for Custom Fields : RATE
   $subtask = substr($task,4);
   if ($subtask) {     // standard vote => task="vote/d" & subtask="fieldname"
      $task = substr($task,0,4);
   }
//   echo "DEBUG: $task : ".$subtask."<br />\n";
}

/*
echo "DEBUG: Task : <b>".$task."</b><br />\n";

foreach ($_POST as $k=>$v) {
  echo "DEBUG: POST $k: $v<br />\n";
}
foreach ($_REQUEST as $k=>$v) {
  echo "DEBUG: REQUEST $k: $v<br />\n";
}
*/

switch ($task) {

    case "view":
      showItem( $id, $option, $catid, $Itemid );
      break;

    case "detail":
      detailItem( $id, $option, $catid, $Itemid, $mode, $search, $access, $navstart );
      break;

    case "wrapper":
      wrapperItem( $id, $option, $catid, $Itemid, $mode, $search, $access, $navstart );
      break;

    case "votd":
      voteItem( $id, $option, $catid, $Itemid, $mode, $search, $rating, $access, $navstart, $subtask, true );
      break;

    case "vote":
      voteItem( $id, $option, $catid, $Itemid, $mode, $search, $rating, $access, $navstart, $subtask );
      break;

    case "edit":
      editbusinessItem( $id, $option, $catid, $Itemid, $mode, $search, $access, $navstart );
      break;

    case "new":
      editbusinessItem( 0, $option, $catid, $Itemid, $mode, $search, $access, $navstart );
      break;

    case "save":
      savebusiness( $option, $catid, $Itemid, $mode, $search, $access, $navstart );
      break;

    case "cancel":
      cancelbusiness( $option, $catid, $Itemid, $mode, $search, $navstart );
      break;

    case "order":
      orderjbd($option, $catid, $Itemid, $mode, $search, $access, $orderbycol, $orderbyupdown, $navstart );
      break;

    case "check":
      checkjbd($id, $option, $catid, $Itemid, $mode, $search, $access, $navstart );
      break;

    case "recommend":
      recommendItem( $id, $option, $catid, $Itemid, $mode, $search, $access, $navstart );
      break;

    case "recommendd":
      recommendItem( $id, $option, $catid, $Itemid, $mode, $search, $access, $navstart, true );
      break;

    case "send":
      sendItem( $id, $option, $catid, $Itemid, $mode, $search, $access, $navstart );
      break;

    case "sendd":
      sendItem( $id, $option, $catid, $Itemid, $mode, $search, $access, $navstart, true );
      break;

    case "list":
    default:
      listjbd( $option, $catid, $Itemid, $mode, $search, $access, $message );
      break;
}



/**
*  Set jbd Order
*/
function orderjbd($option, $catid, $Itemid, $mode, $search, $access, $orderbycol, $orderbyupdown ) {
   global $my;

   mosjbdTools::setPref($my->id, "sortfront", "frontcol", $orderbycol);
   mosjbdTools::setPref($my->id, "sortfront", "frontorder", $orderbyupdown);

   listjbd( $option, $catid, $Itemid, $mode, $search, $access, "" );
}



function getCats ($catid, &$categories, &$catlevel, $catlevelmax, $sqlorder, $showroot, &$params) {
   global $mainframe, $database, $my;

   $haslinks = 0;

   // *** get Cat info
   // bc = jbdCategories
   $Query = "SELECT bc.id as catid, bc.title, bc.name, bc.parent, bc.ordering, bc.icon, bc.description"
       . "\n FROM #__jbd_categories AS bc"
       . "\n WHERE bc.id=$catid"
       . "\n AND bc.published=1"
       . "\n AND bc.access<='$my->gid'"
   ;
   $database->setQuery( $Query );
   $database->loadObject( $cat );

//echo "DEBUG: ".$database->getQuery()."<br />\n";

   if ($cat) {  // Some Cats found - Get subs-cats

      if ($params->allowprivate && strtolower($my->usertype) != 'super administrator') {
         $sqlprivate = ' AND ( (b.private = 0) OR (b.private = 1 AND b.created_by = ' .$my->id. ') )';
      } else {
         $sqlprivate = '';  // show all jbd
      }

      // *** Count Links
      if ( !$params->showemptycats || ($params->catshowcount && !($params->catshowcount == 3 && $params->showemptycats) ) ) {      // Count business only if necessary and hiding empty cats...
         // b = jbd
         // i = jbdItemCat
         $Query = "SELECT count(b.id)"
             . "\n FROM #__jbd_itemcat AS i"
             . "\n LEFT JOIN #__jbd AS b ON b.id = i.itemid"
             . "\n WHERE (i.catid = " .$catid. ")"
             . "\n AND (b.published = 1 AND b.approved = 1 AND b.archived = 0)"
             . $sqlprivate
             . "\n AND b.access <= '$my->gid'"
         ;
         $database->setQuery( $Query );
         $numlinks = intval($database->loadResult());

// echo "DEBUG: [cat:$catid] =>".$database->getQuery()."<br />\n";

      } else {
         $numlinks = -1;  // Indicate that we do not care about counting...
// echo "DEBUG: [cat:$catid] => No Query...<br />\n";
      }


      $cat->numlinks = (isset($numlinks)) ? $numlinks : 0;   // Variable is defined...

      $haslinks = ($cat->numlinks || $cat->numlinks == -1);  // Check if we do have links...

      if ( ($catlevel < $catlevelmax ) ) {   // Limit the subcats tree to [catmaxlevel] levels

//      if ($params->catshowcount == 1 || $params->catshowcount == 3) {  // Count jbd only if necessary...
         // Get Subcats
         // bc = jbdCategories
         $Query = "SELECT bc.id as catid, bc.title, bc.name, bc.parent, bc.ordering, bc.icon"
             . "\n FROM #__jbd_categories AS bc"
             . "\n WHERE bc.parent=$catid"
             . "\n AND bc.published=1"
             . "\n AND bc.access <= '$my->gid'"
             . $sqlorder
         ;
         $database->setQuery( $Query );
         $subcats = $database->loadObjectList();

// echo "DEBUG: ".$database->getQuery()."<br />\n";

//      } else {
//         $subcats = -1;  // Do not care counting...
//      }

      $cat->numchild = (isset($subcats)) ? count($subcats) : 0;

      if ( $showroot || ( !$showroot && $catlevel > 0 ) ) {
        if ($params->showemptycats || $cat->numlinks || $cat->numchild ) {    // Found some subcats or links => display the category
           $categories[] = $cat;       // store cats info into an Array
           $curcat = count($categories)-1;  // save Cat position in list
        }
      }

      $catlevel++;
      if ($subcats && ($catlevel < $catlevelmax ) ) {   // limit the subcats tree to [catmaxlevel] levels
//      if ($subcats ) {   // limit the subcats tree to [catmaxlevel] levels
         if ($params->catdisplayorder!=2 && ($catlevel == $catlevelmax) ) {
            $maxsubcats = $params->subcatsdisplay;  // limit sub-cats (only on last level...)
         } else {
            $maxsubcats = count($subcats);          // Show All sub-cats
         }
         for ($ii=0; $ii < $maxsubcats; $ii++) {
            $subcat = $subcats[$ii];
            $links = getCats($subcat->catid, $categories, $catlevel, $catlevelmax, $sqlorder, $showroot, $params);    // get sub-cats
            if (isset($curcat)) {  // stored parent cat
               if (!$params->showemptycats && $links == 0 ) {    // Not Found links in subcats => hide cat and decrease child count
                  $categories[$curcat]->numchild--;
               }
            }
         }
      }
      }
      $catlevel--;
   }

   return $haslinks;
}


/**
*  List jbd
*/
function listjbd( $option, $catid, $Itemid, $mode, $search, $access, $msg="" ) {
    global $mainframe, $database, $my;
    global $mosConfig_shownoauth;
    global $alphaIndex;

    $pagetitlesep = ' / ';

    if (!$catid) {
        $catid = -1;  // Root Cat (ID = -1)
    } else {
       if ($catid > 0) {

          // **** SQL : check first if category is published

          $Query = "SELECT bc.published"
              . "\n FROM #__jbd_categories AS bc"
              . "\n WHERE bc.id=$catid"
          ;
          $database->setQuery( $Query );
          $catpublished = $database->loadResult();

          if (!$catpublished) {
             mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=0&search=$search") );
          }
       }
    }

    mosjbdTools::LoadjbdParams ($params);  // retrieve all params

/*
    // *** Params for buttons : "print / pdf / mail"
	$params->print = !$mainframe->getCfg( 'hidePrint' );
	$params->pdf = !$mainframe->getCfg( 'hidePdf' );
	$params->email = !$mainframe->getCfg( 'hideEmail' );
*/

    if ($search == "") { $search = $params->defaultsearch; }
    $params->search = $search;
    $params->mode = $mode;
    $params->navstart = intval( mosGetParam( $_REQUEST, 'navstart', 0 ) );  // Navigation : retrieve the page # to display;
    $params->pagetitle = _BM_jbd;

    if ($params->navigatorpos == 0) {  // If the navigator is hidden, the ensure that the navigation system is also disabled ( => navperage = 0 ) !!!
       $params->navstart = 0;
       $params->navperpage = 0;
    }

//    echo "DEBUG: Search ".$params->search."<br />\n";

    // *** Load user's specific column sorting
    $orderbycol = mosjbdTools::getPref($my->id,'sortfront',"frontcol", "title");
    $orderbyupdown = mosjbdTools::getPref($my->id,'sortfront',"frontorder", "asc");

    if ($params->allowprivate && strtolower($my->usertype) != 'super administrator') {
       $sqlprivate = "\n AND ( (b.private = 0) OR (b.private = 1 AND b.created_by = " .$my->id. ") )";
    } else {
       $sqlprivate = "";
    }

    if ($params->cancredit && $params->reducerating == -1 && $my->usertype != "Super Administrator") {
       $sqlcredits = 'AND ( (b.credits > 0) OR (b.credits = -1) )';      // Hide links with credits = 0
    } else {
       $sqlcredits = '';
    }

    // *** Build Search Filter
    if ( $params->showsearchbox || $params->showalphaindex ) { // Apply filter only if SearchBox or AlphaIndex are visible...
       $search = strtolower($search);
       $searchpattern = "";
       if ( strlen($search) > 1 ) {
          $searchpattern = "\n AND LOWER(b.title) LIKE '%$search%'";
       } else {
          if ( strlen($search) == 1 ) {
             if ($search == "*") {  // All jbd...
                $searchpattern = "";
             } elseif ($search == "]") {
                $searchpattern = "\n AND LOWER(b.title) < '".strtolower($alphaIndex[1])."'";
             } elseif ($search == "[") {
                $searchpattern = "\n AND LOWER(b.title) > '".strtolower($alphaIndex[count($alphaIndex)-2])."Z'";
             } else {
                $searchpattern = "\n AND LOWER(b.title) LIKE '$search%'";
             }
          } else {
             $searchpattern = "";
          }
       }
    } else {
       $searchpattern = "";
    }

    // *** Define jbd sort order
    if ($orderbycol == 'created' || $orderbycol == 'rating' || $orderbycol == 'hits' ) {  // For Numeric field => invert sorting order
       if ($orderbyupdown == "asc") {
          $orderbyupdown_tmp = "desc";
       } else {
          $orderbyupdown_tmp = "asc";
       }
    } else {
          $orderbyupdown_tmp = $orderbyupdown;
    }

    // *** Verify Available fields for Column sorting
    $key = -1;
    $first = -1;
    for ($i=0; $i < count($params->columns); $i++) {
       $tcol = &$params->columns[$i];
       if ( $tcol->visible ) {
          if ($first == -1) { $first = $i; }      // Save first visible column
          if ( $tcol->name != 'detail' && $tcol->name != 'category' && $tcol->name != 'keywords' && $tcol->name != 'credits') {    // Skip hidden columns
//echo "DEBUG: name : ".strtolower($tcol->name)."  Custom : ".$tcol->custom." => ".$orderbycol."<br />\n";
             if ( strtolower($tcol->name) == $orderbycol ) {
                $key = $i;
             }
          }
       }
    }
    unset($tcol);      // Unassign "$tcol" to avoid side effect with variable as it is always pointing to the the real data

    if ($key >= 0 ) {
    } else {  // no fields
       $orderbycol = 'title';
    }

    switch ($params->mode) {

      case "0" : // One cat
      default :

          if ($search != "") {

             // *** Define Categories sort order
             if (!$params->catsort) {
                $sqlorder = "\n ORDER BY bc.name ASC";
             } else {
                $sqlorder = "\n ORDER BY bc.ordering ASC";
             }

             // *** SQL : Retrieve Categories
             if ($params->catdisplayorder == 2) {   // *** Display Tree : All Cats & All Sub-cats from Root (-1)
                $categories = array();
                $catlevel = 0;
                getCats('-1', $categories, $catlevel, 9999, $sqlorder, true, $params);  // Get Sub-Cats : Whole tree from RootCat (ID = -1)
             } else {                               // *** Display Cats & Sub-Cats from current cat
                $categories = array();
                $catlevel = 0;
                getCats($catid, $categories, $catlevel, 3, $sqlorder, false, $params);  // Get Sub-Cats : 2 levels (cats & subcats only)
             }

             if ($params->adminratesort) {
               $goldorder = 'b.ratingadmin DESC, ';
             } else {
               $goldorder = '';
             }

             if ($params->bmsort == 1) {            // Manual Sort
                if ( $orderbycol == 'title' ) { $orderbycol = 'ordering'; }
                if ( $orderbycol == "ordering" ) {
                   $sqlorder = "\n ORDER BY $goldorder i.ordering $orderbyupdown_tmp, b.title $orderbyupdown_tmp";
                } else {
                   $sqlorder = "\n ORDER BY $goldorder b.$orderbycol $orderbyupdown_tmp, i.ordering ASC";
                }
             } elseif ($params->bmsort == 2) {      // Sorted by creation date
                if ( $orderbycol == 'title' || $orderbycol == 'ordering') { $orderbycol = 'created'; }
                if ( $orderbycol == "created" ) {
                   $sqlorder = "\n ORDER BY " .$goldorder. "b.created $orderbyupdown_tmp, b.title $orderbyupdown_tmp";
                } else {
                   $sqlorder = "\n ORDER BY " .$goldorder. "b.$orderbycol $orderbyupdown_tmp, b.created DESC";
                }
             } else {                               // Alpha Sort
                if ( $orderbycol == 'ordering' ) { $orderbycol = 'title'; }
                $sqlorder = "\n ORDER BY " .$goldorder. "b.$orderbycol $orderbyupdown_tmp, b.title ASC";
             }

//echo "DEBUG:  : ".$params->bmsort."<br />\n";
//echo "DEBUG:  : ".$orderbycol." - ".$orderbyupdown_tmp."<br />\n";


             // *** SQL : Retrieve jbd
             $pathcat = "";

             // Updated Query to neither display unapproved nor unpublished jbd or categories !
             // b  = jbd
             // bc = jbdCategories
             // i  = jbdItemCategories
             $Querya = "SELECT count(b.id) AS total";
             $Queryb = "SELECT b.*, i.ordering, u.name AS username";
             $Queryc = "\n FROM #__jbd AS b"
                     . "\n LEFT JOIN #__jbd_itemcat as i ON i.itemid = b.id"
                     . "\n LEFT JOIN #__users AS u ON u.id = b.created_by"
                     . "\n WHERE (i.catid = $catid)"
                     . "\n AND (b.published = 1 AND b.approved = 1 AND b.archived = 0)"
                     . "\n AND b.access <= '$my->gid'"
                     . $searchpattern
                     . $sqlprivate
                     . $sqlcredits
                     . $sqlorder
             ;

             // Count jbd : Total
             $database->setQuery( $Querya.$Queryc );
             $params->navtotal = $database->loadResult();

//echo "DEBUG: ".$database->getQuery()."<br />\n";

             // Retrieve jbd according to per page limit or all (no limit)
             if ($params->navperpage == 0) {

                $database->setQuery( $Queryb.$Queryc );

             } else {

                $params->navfloor = floor($params->navtotal / $params->navperpage);
                $params->navend = ( ($params->navfloor*$params->navperpage) == $params->navtotal ) ? $params->navfloor-1 : $params->navfloor;
                $params->navstart = ($params->navstart > $params->navend ) ? $params->navend : $params->navstart;
                $params->navstart = ($params->navstart < 0 ) ? 0 : $params->navstart;

                $Queryd = "\n LIMIT ".$params->navstart*$params->navperpage.", ".$params->navperpage;

                $database->setQuery( $Queryb.$Queryc.$Queryd );
             }

             $rows = $database->loadObjectList();

//echo "DEBUG: ".$database->getQuery()."<br />\n";

             for ($i=0; $i<count($rows); $i++) {

                $row = &$rows[$i];  // !!! &$rows means to use variable by reference (=> Pointer) and not by Value (=> Copy)

                $Query = "SELECT bc.name as category"
                    . "\n FROM #__jbd_itemcat i"
                    . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
                    . "\n WHERE (i.itemid = ".$row->id.")"
                    . "\n ORDER BY bc.name ASC"
                ;

                $database->setQuery( $Query );
                $cats = $database->loadResultArray();

                $row->categories = $cats;
                $row->category = $cats[0];

             }

             $Query = "SELECT bc.*"
                 . "\n FROM #__jbd_categories AS bc"
                 . "\n WHERE bc.id = $catid"
             ;
             $currentcat=null;
             $database->setQuery( $Query );
             $database->loadObject($currentcat);

//echo "DEBUG: ".$database->getQuery()."<br />\n";

             // *** Keywords Category
             $mainframe->appendMetaTag( 'keywords', $currentcat->keywords );

             switch ($params->dynamictitlerevorder) {   // Page Title in Reversed order ?
               case "1" :  // Reverse
                   $scats = split(' / ',$currentcat->name);
                   $n = "";
                   foreach ($scats as $scat) {
                     $n = ($n != "") ? $scat . ' / ' . $n : $scat;
                   }
                   $params->pagetitle = $n . $pagetitlesep . $params->pagetitle;
                   break;
               case "2" :  // Hidden  ( Only display "jbd" no categories...
                   break;
               case "0" :  // Normal
               default :
                   $params->pagetitle .= $pagetitlesep . $currentcat->name;
             }

          } else {
             $currentcat = null;
             $categories = array();
             $rows=null;
          }

          break;


      case "1" :  // All Grouped by Alpha

          if ($search != "") {

             if ($params->adminratesort) {
               $goldorder = 'b.ratingadmin DESC, ';
             } else {
               $goldorder = '';
             }

             if ($orderbycol == "ordering") {
                $sqlorder = $goldorder . "i.ordering $orderbyupdown_tmp";     // Trick to prevent ambiguity on the field name...
             } else {
                $sqlorder = $goldorder . "b.$orderbycol $orderbyupdown_tmp";  // Trick to prevent ambiguity on the field name...
             }

             // SQL : Get jbd List (Sorted Alpha)

             // Updated Query to neither display unapproved nor unpublished jbd or categories !
             // b  = jbd
             // bc = jbdCategories
             // i  = jbdItemCategories
             $Querya = "SELECT count(DISTINCT b.id) AS total";
             $Queryb = "SELECT DISTINCT b.*, u.name as username";
             $Queryc = "\n FROM #__jbd_itemcat i"
                     . "\n INNER JOIN #__jbd b ON (i.itemid = b.id)"
                     . "\n LEFT OUTER JOIN #__users as u ON (b.created_by = u.id)"
                     . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
                     . "\n WHERE ( (b.published = 1) AND (b.archived = 0) AND (b.approved = 1) AND (b.access <= '$my->gid') )"
                     . "\n AND ( ( (bc.access <= '$my->gid') AND (bc.published = 1) ) OR ( (bc.id is null) ) )"
                     . $searchpattern
                     . $sqlprivate
                     . $sqlcredits
                     . "\n ORDER BY LEFT(b.title,1) ASC, $sqlorder"
             ;

             // Count jbd : Total
             $database->setQuery( $Querya.$Queryc );
             $params->navtotal = $database->loadResult();

             // Retrieve jbd according to per page limit or all (no limit)
             if ($params->navperpage == 0) {

                $database->setQuery( $Queryb.$Queryc );

             } else {

                $params->navfloor = floor($params->navtotal / $params->navperpage);
                $params->navend = ( ($params->navfloor*$params->navperpage) == $params->navtotal ) ? $params->navfloor-1 : $params->navfloor;
                $params->navstart = ($params->navstart > $params->navend ) ? $params->navend : $params->navstart;
                $params->navstart = ($params->navstart < 0 ) ? 0 : $params->navstart;

                $Queryd = "\n LIMIT ".$params->navstart*$params->navperpage.", ".$params->navperpage;

                $database->setQuery( $Queryb.$Queryc.$Queryd );

             }

             $rows = $database->loadObjectList();

             for ($i=0; $i<count($rows); $i++) {

                $row = &$rows[$i];  // !!! &$rows means to use variable by reference (=> Pointer) and not by Value (=> Copy)

                $Query = "SELECT bc.name as category"
                    . "\n FROM #__jbd_itemcat i"
                    . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
                    . "\n WHERE (i.itemid = ".$row->id.")"
                    . "\n ORDER BY bc.name ASC"
                ;

                $database->setQuery( $Query );
                $cats = $database->loadResultArray();

                $row->categories = $cats;
                $row->category = $cats[0];

             }

             $pathcat = "";
             $categories = array();
             $currentcat = null;

             switch ($params->dynamictitlerevorder) {   // Page Title in Reversed order ?
               case "1" :  // Reverse
                   $params->pagetitle = _BMU_DISPLAY_BYALPHA . $pagetitlesep . $params->pagetitle;
                   break;
               case "2" :  // Hidden  ( Only display "jbd" no categories...
                   break;
               case "0" :  // Normal
               default :
                   $params->pagetitle .= $pagetitlesep. _BMU_DISPLAY_BYALPHA;
             }


          } else {
             $currentcat = null;
             $categories = array();
             $rows=null;
          }

          break;


      case "2" : // All by Cats

          if ($search != "") {

             // *** Define Categories sort order
             if (!$params->catsort) {
                $sqlorder1 = "bc.name ASC";
             } else {
                $sqlorder1 = "bc.ordering ASC";
             }

             if ($params->adminratesort) {
               $goldorder = 'b.ratingadmin DESC, ';
             } else {
               $goldorder = '';
             }

             if ($params->bmsort == 1) {            // Manual Sort
                if ( ($orderbycol == 'title') ) { $orderbycol = 'ordering'; }
                if ( ($orderbycol == "ordering") ) {
                   $sqlorder2 = $goldorder . "i.ordering $orderbyupdown_tmp";        // Trick to prevent ambiguity on the field name...
                } else {
                   $sqlorder2 = $goldorder . "b.$orderbycol $orderbyupdown_tmp";     // Trick to prevent ambiguity on the field name...
                }
             } elseif ($params->bmsort == 2) {            // Creation Date Sort
                if ( $orderbycol == 'title' || $orderbycol == 'ordering') { $orderbycol = 'created'; }
                if ( $orderbycol == "created" ) {
                   $sqlorder2 = $goldorder . "b.created $orderbyupdown_tmp";         // Trick to prevent ambiguity on the field name...
                } else {
                   $sqlorder2 = $goldorder . "b.$orderbycol $orderbyupdown_tmp";     // Trick to prevent ambiguity on the field name...
                }
             } else { // Alpha Sorting
                if ( $orderbycol == 'ordering' ) { $orderbycol = 'title'; }
                if ( $orderbycol == "title" ) {
                   $sqlorder2 = $goldorder . "b.title $orderbyupdown_tmp";           // Trick to prevent ambiguity on the field name...
                } else {
                   $sqlorder2 = $goldorder . "b.$orderbycol $orderbyupdown_tmp";     // Trick to prevent ambiguity on the field name...
                }
             }


           // SQL : Get jbd List (Sorted Cats)

             // Updated Query to neither display unapproved nor unpublished jbd or categories !
             // b  = jbd
             // bc = jbdCategories
             // i  = jbdItemCategories
             $Querya = "SELECT count(b.id) AS total";
             $Queryb = "SELECT bc.id AS catid, bc.name AS category, bc.description as catdesc, bc.image, bc.image_position, bc.icon, bc.keywords, b.*, i.ordering, u.name as username";
             $Queryc = "\n FROM #__jbd_itemcat i"
                     . "\n INNER JOIN #__jbd b ON (i.itemid = b.id)"
                     . "\n LEFT OUTER JOIN #__users as u ON (b.created_by = u.id)"
                     . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
                     . "\n WHERE ( (b.published = 1) AND (b.archived = 0) AND (b.approved = 1) AND (b.access <= '$my->gid') )"
                     . "\n AND ( ( (bc.access <= '$my->gid') AND (bc.published = 1) ) OR ( (bc.id is null) ) )"
                     . $searchpattern
                     . $sqlprivate
                     . $sqlcredits
                     . "\n ORDER BY $sqlorder1, $sqlorder2, b.title ASC"
             ;

             // Count jbd : Total
             $database->setQuery( $Querya.$Queryc );
             $params->navtotal = $database->loadResult();

             // Retrieve jbd according to per page limit or all (no limit)
             if ($params->navperpage == 0) {

                $database->setQuery( $Queryb.$Queryc );

             } else {

                $params->navfloor = floor($params->navtotal / $params->navperpage);
                $params->navend = ( ($params->navfloor*$params->navperpage) == $params->navtotal ) ? $params->navfloor-1 : $params->navfloor;
                $params->navstart = ($params->navstart > $params->navend ) ? $params->navend : $params->navstart;
                $params->navstart = ($params->navstart < 0 ) ? 0 : $params->navstart;

                $Queryd = "\n LIMIT ".$params->navstart*$params->navperpage.", ".$params->navperpage;

                $database->setQuery( $Queryb.$Queryc.$Queryd );
             }
// echo "DEBUG: ".$database->getQuery()."<br />\n";

             $rows = $database->loadObjectList();

             for ($i=0; $i<count($rows); $i++) {

                $row = &$rows[$i];  // !!! &$rows means to use variable by reference (=> Pointer) and not by Value (=> Copy)

                $Query = "SELECT bc.name as category"
                    . "\n FROM #__jbd_itemcat i"
                    . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
                    . "\n WHERE (i.itemid = ".$row->id.")"
                    . "\n ORDER BY bc.name ASC"
                ;

                $database->setQuery( $Query );
                $cats = $database->loadResultArray();

                $row->categories = $cats;

             }

             $pathcat = "";
             $categories = array();
             $currentcat = null;

             switch ($params->dynamictitlerevorder) {   // Page Title in Reversed order ?
               case "1" :  // Reverse
                   $params->pagetitle = _BMU_DISPLAY_BYCATS . $pagetitlesep . $params->pagetitle;
                   break;
               case "2" :  // Hidden  ( Only display "jbd" no categories...
                   break;
               case "0" :  // Normal
               default :
                   $params->pagetitle .= $pagetitlesep. _BMU_DISPLAY_BYCATS;
             }

          } else {
             $currentcat = null;
             $categories = array();
             $rows=null;
          }

          break;


      case "3" :  // All sorted by Alpha but not grouped

          if ($search != "") {

             if ($params->adminratesort) {
               $goldorder = 'b.ratingadmin DESC, ';
             } else {
               $goldorder = '';
             }

             if ($params->bmsort == 1) {            // Manual Sort
                if ( $orderbycol == 'title' ) { $orderbycol = 'ordering'; }
             } elseif ($params->bmsort == 2) {      // Sorted by creation date
                if ( $orderbycol == 'title' || $orderbycol == 'ordering') { $orderbycol = 'created'; }
             } else {                               // Alpha Sort
                if ( $orderbycol == 'ordering' ) { $orderbycol = 'title'; }
             }


             if ($orderbycol == "ordering") {
                $sqlorder = $goldorder . "i.ordering $orderbyupdown_tmp";     // Trick to prevent ambiguity on the field name...
             } else {
                $sqlorder = $goldorder . "b.$orderbycol $orderbyupdown_tmp";  // Trick to prevent ambiguity on the field name...
             }

             // SQL : Get jbd List (Sorted Alpha)

             // Updated Query to neither display unapproved nor unpublished jbd or categories !
             // b  = jbd
             // bc = jbdCategories
             // i  = jbdItemCategories
             $Querya = "SELECT count(DISTINCT b.id) AS total";
             $Queryb = "SELECT DISTINCT b.*, u.name as username";
             $Queryc = "\n FROM #__jbd_itemcat i"
                     . "\n INNER JOIN #__jbd b ON (i.itemid = b.id)"
                     . "\n LEFT OUTER JOIN #__users as u ON (b.created_by = u.id)"
                     . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
                     . "\n WHERE ( (b.published = 1) AND (b.archived = 0) AND (b.approved = 1) AND (b.access <= '$my->gid') )"
                     . "\n AND ( ( (bc.access <= '$my->gid') AND (bc.published = 1) ) OR ( (bc.id is null) ) )"
                     . $searchpattern
                     . $sqlprivate
                     . $sqlcredits
                     . "\n ORDER BY $sqlorder, b.title ASC"
             ;

             // Count jbd : Total
             $database->setQuery( $Querya.$Queryc );
             $params->navtotal = $database->loadResult();

             // Retrieve jbd according to per page limit or all (no limit)
             if ($params->navperpage == 0) {

                $database->setQuery( $Queryb.$Queryc );

             } else {

                $params->navfloor = floor($params->navtotal / $params->navperpage);
                $params->navend = ( ($params->navfloor*$params->navperpage) == $params->navtotal ) ? $params->navfloor-1 : $params->navfloor;
                $params->navstart = ($params->navstart > $params->navend ) ? $params->navend : $params->navstart;
                $params->navstart = ($params->navstart < 0 ) ? 0 : $params->navstart;

                $Queryd = "\n LIMIT ".$params->navstart*$params->navperpage.", ".$params->navperpage;

                $database->setQuery( $Queryb.$Queryc.$Queryd );
             }

             $rows = $database->loadObjectList();

             for ($i=0; $i<count($rows); $i++) {

                $row = &$rows[$i];  // !!! &$rows means to use variable by reference (=> Pointer) and not by Value (=> Copy)

                $Query = "SELECT bc.name as category"
                    . "\n FROM #__jbd_itemcat i"
                    . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
                    . "\n WHERE (i.itemid = ".$row->id.")"
                    . "\n ORDER BY bc.name ASC"
                ;

                $database->setQuery( $Query );
                $cats = $database->loadResultArray();

                $row->categories = $cats;
                $row->category = $cats[0];

             }

             $pathcat = "";
             $categories = array();
             $currentcat = null;

             switch ($params->dynamictitlerevorder) {   // Page Title in Reversed order ?
               case "1" :  // Reverse
                   $params->pagetitle = _BMU_DISPLAY_BYALPHA . $pagetitlesep . $params->pagetitle;
                   break;
               case "2" :  // Hidden  ( Only display "jbd" no categories...
                   break;
               case "0" :  // Normal
               default :
                   $params->pagetitle .= $pagetitlesep. _BMU_DISPLAY_ALLALPHA;
             }

          } else {
             $currentcat = null;
             $categories = array();
             $rows=null;
          }

          break;


        default:
             $currentcat = null;
             $categories = array();
             $rows=null;

    }

    // *** make the select list for the rating vote
    $vote[] = mosHTML::makeOption( '5', '5' );
    $vote[] = mosHTML::makeOption( '4', '4' );
    $vote[] = mosHTML::makeOption( '3', '3' );
    $vote[] = mosHTML::makeOption( '2', '2' );
    $vote[] = mosHTML::makeOption( '1', '1' );

    // *** build the HTML select list [Rating]
    $lists->rating = mosHTML::selectList( $vote, 'rating', 'class="inputbox" size="1"', 'value', 'text', 0 );

    // *** build the HTML select list [Custom Fields]
    foreach ($params->columns as $column) {
       if ($column->f_type == 8) {   // Type : RATE
          $name = 'f_'.$column->name;
          $lists->$name = mosHTML::selectList( $vote, 'rating', 'class="inputbox" size="1"', 'value', 'text', 0 );
      }
    }

    // *** Page Title
    $mainframe->SetPageTitle($params->pagetitle);

    // *** Pathway Global
    if ($params->showpathway == 1 || $params->showpathway == 3) {
       switch ($params->mode) {
         case "1" :
             $pathway =_BMU_DISPLAY_BYALPHA;
             break;
         case "2" :
             $pathway = _BMU_DISPLAY_BYCATS;
             break;
         case "3" :
             $pathway = _BMU_DISPLAY_ALLALPHA;
             break;
         case "0" :
         default :
             $pathway = displayPathCat($option, $catid, $Itemid, $mode, $search, true);
       }
       if ($params->showdisplaymode || ( !$params->showdisplaymode && $params->mode == 0 ) ) {
          $mainframe->appendPathWay( $pathway );
       }
    }

    // *** Pathway jbd only
    if ($params->showpathway == 1 || $params->showpathway == 2) {
       $pathcat = displayPathCat($option, $catid, $Itemid, $mode, $search, false);
    } else {
       $pathcat = "";
    }

    // *** Keywords jbd
    if ($rows) {
       foreach ($rows as $r) {
          $mainframe->appendMetaTag( 'keywords', $r->keywords );
       }
    }

    // *** Display results
    HTML_jbd::displaylist( $option, $categories, $rows, $catid, $currentcat, $pathcat, $lists, $access, $msg, $orderbycol, $orderbyupdown, $params);
}


/**
*  Display the Category Pathway (parents)
*/
function displayPathCat($option, $catid=0, $Itemid, $mode, $search, $pathway=false) {
    global $database;

    $txt = "";
    $ref = "";
    $curcat = $catid;
    $level = 0;

    $params->csspathway = mosjbdTools::getPref(-1,'params','csspathway', 'category');

    while ( $curcat != -2 ) { // Until Cat is RootCat's parent (-2)...

       $database->setQuery("SELECT id, title, parent"
                      . "\n FROM #__jbd_categories"
                      . "\n WHERE id='$curcat'"
       );

       $database->loadObject($row);

       if ($row->id != $catid) {
           $tref = '<a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=".$row->id."&search=$search"). '"';
           $tref .= ($pathway) ? ' class="pathway"' : mosjbdTools::cssClass($params->csspathway);
           $tref .= '>';
           $tref .= htmlspecialchars($row->title, ENT_NOQUOTES);
           $tref .= '</a>&nbsp;';
           $ref = $tref . $ref;
       } else {
           $tref = '';
           if (!$pathway) {
              $tref .= '<span';
              $tref .= mosjbdTools::cssClass($params->csspathway);
              $tref .= '>';
           }
           $tref .= htmlspecialchars($row->title, ENT_NOQUOTES) . '&nbsp;';
           if (!$pathway) {
              $tref .= '</span>';
           }
           $ref = $tref . $ref;
       }

       if ($row->id != -1) {  // Add arrow if not found the whole branch
         $ref = mosjbdTools::imageArrow() . '&nbsp;' . $ref;
       }

       $curcat = $row->parent;    // Get parent Cat...
       $level++;
    }

    if (!$pathway) {
       $ref = mosjbdTools::imageArrow() . '&nbsp;' . $ref;
    }

    return $ref;
}


/**
*  Launch a jbd (with hits update)
*/
function showItem ( $id, $option, $catid=0, $Itemid ) {
    global $database, $my, $mainframe;

    mosjbdTools::LoadjbdParams($params);

    if ($params->allowprivate && $my->usertype != 'Super Administrator') {
       $sqlprivate = 'AND ( (b.private = 0) OR (b.private = 1 AND b.created_by = ' .$my->id. ') )';
    } else {
       $sqlprivate = '';
    }

    if ($params->cancredit && $params->reducerating == -1 && $my->usertype != "Super Administrator") {
       $sqlcredits = 'AND ( (b.credits > 0) OR (b.credits = -1) )';
    } else {
       $sqlcredits = '';
    }

    $database->setQuery( "SELECT b.*"
                    . "\n FROM #__jbd as b"
                    . "\n LEFT JOIN #__jbd_itemcat as i ON i.itemid = b.id"
                    . "\n LEFT JOIN #__jbd_categories as bc ON (bc.id = i.catid OR i.catid = -1)"  // Root Cat = -1
                    . "\n WHERE b.id = $id"
                    . "\n AND b.access <= '$my->gid'"
                    . "\n AND (b.published = 1 AND b.approved = 1 AND b.archived = 0)"
                    . "\n AND bc.access <= '$my->gid'"
                    . "\n AND (bc.published = 1 OR bc.id = 0)"
                    . "\n ".$sqlprivate
                    . "\n ".$sqlcredits
    );
    $database->loadObject($row);

    if ($row->id) {  // Valid business

       $mainframe->appendMetaTag( 'keywords', $row->keywords );

       if ($row->url != "" ) {  // Valid URL

          $params->hitdetail = mosjbdTools::getPref(-1,'params','hitdetail', '0');

          if ( $row->redirect != 1 || ( $row->redirect == 1 && !$params->hitdetail ) ) {  // If the hit is done on detail not when opening url.
             $item = new mosbusiness( $database );
             $item->load($row->id);
             $item->hit($option, $Itemid);
          }

          // *** Redirect to URL

          if ($params->mosredirect) {
             // *** New redirect method => use HTML "refresh" function to avoid search engines indexation => Allow to apply the "noindex" param !
             //     => !!! Special Thanks to Jrgen for the tip !!!

             global $mosConfig_sitename;

             ob_clean();     // Clean any output made up to now...
             // *** Create a simple redirect page
             echo "<!DOCTYPE HTML PUBLIC '-//W3C//DTD HTML 4.01 Transitional//EN' 'http://www.w3.org/TR/html4/loose.dtd'>\n";
             echo '<html><head><title>' . $mosConfig_sitename . ' - ' . _BMU_REDIRECT_business . '</title>'."\n";
             echo "<meta name='robots' content='noindex, follow'>"."\n";
             echo "<meta http-equiv='refresh' content='0;url=$row->url'>"."\n";
             echo '</head>'."\n";
             echo'<body>'."\n";
             if ($params->mosredirect == 2) {
                echo '<b><u>'. _BMU_REDIRECT_business . '</u></b> : <br />'."\n";
                echo '<br />'."\n";
                echo _BMU_business. ' : [' . $row->id . '] <b>'. $row->title .'</b><br />'."\n";
                echo 'URL : <a href="' .$row->url. '">' .$row->url. '</a><br />'."\n";
                echo '<br />'."\n";
                echo '<i>'._BMU_REDIRECT_NOT_WORKING.'</i><br />'."\n";
             }
             echo '</body></html>';
             // *** Stop script here and produce output
             exit();
          } else {
             // *** Old redirect method => but get indexed by Search engines...
             mosRedirect ( $row->url );
          }

       } else {  // No URL => back to list...
          listjbd( $option, $catid, $Itemid, $mode, $search, $access, "" );
       }

    } else {     // Not found or Not authorized...
          echo "<script type='text/javascript'> alert('" ._BMU_SORRY_NO_business. "');</script>\n";
          exit;
    }
}


/**
*  View business Detail
*/
function detailItem ( $id, $option, $catid=0, $Itemid, $mode, $search, $access, $navstart ) {
    global $database, $my, $mainframe;

    mosjbdTools::LoadjbdParams($params);

    $params->navstart = intval( mosGetParam( $_REQUEST, 'navstart', 0 ) );  // Navigation : retrieve the page # to display

    if ($params->allowprivate && $my->usertype != 'Super Administrator') {
       $sqlprivate = 'AND ( (b.private = 0) OR (b.private = 1 AND b.created_by = ' .$my->id. ') )';
    } else {
       $sqlprivate = '';
    }

    if ($params->cancredit && $params->reducerating == -1 && $my->usertype != "Super Administrator") {
       $sqlcredits = 'AND ( (b.credits > 0) OR (b.credits = -1) )';
    } else {
       $sqlcredits = '';
    }

    $database->setQuery( "SELECT b.*, u.name as username"
                    . "\n FROM #__jbd_itemcat as i"
                    . "\n LEFT JOIN #__jbd AS b ON b.id = i.itemid"
                    . "\n LEFT JOIN #__jbd_categories AS bc ON (bc.id = i.catid OR i.catid = -1)"  // Root Cat = -1
                    . "\n LEFT JOIN #__users AS u ON u.id = b.created_by"
                    . "\n WHERE i.itemid = $id"
                    . "\n AND b.access <= '$my->gid'"
                    . "\n AND (b.published = 1 AND b.approved = 1 AND b.archived = 0)"
                    . "\n AND bc.access <= '$my->gid'"
                    . "\n AND (bc.published = 1 OR bc.id = 0)"
                    . "\n ".$sqlprivate
                    . "\n ".$sqlcredits
    );
    $database->loadObject($row);

    if ($row->id != "") {  // Valid business

       $Query = "SELECT bc.name as category"
           . "\n FROM #__jbd_itemcat i"
           . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
           . "\n WHERE (i.itemid = ".$row->id.")"
           . "\n ORDER BY bc.name ASC"
       ;

       $database->setQuery( $Query );
       $cats = $database->loadResultArray();

       $row->categories = $cats;
       $row->category = $cats[0];

       if ( $row->url == "" || $params->hitdetail ) {  // If URL is empty or if the hit is done on detail not when opening url.
          $item = new mosbusiness( $database );
          $item->load($row->id);
          $item->hit($option, $Itemid);
       }

       // *** User can vote in the detailpage
       if ($params->canvotedetail) {

          // *** make the select list for the rating vote
          $vote[] = mosHTML::makeOption( '5', '5' );
          $vote[] = mosHTML::makeOption( '4', '4' );
          $vote[] = mosHTML::makeOption( '3', '3' );
          $vote[] = mosHTML::makeOption( '2', '2' );
          $vote[] = mosHTML::makeOption( '1', '1' );

          // *** build the HTML select list [Rating]
          $lists->rating = mosHTML::selectList( $vote, 'rating', 'class="inputbox" size="1"', 'value', 'text', 0 );

          // *** build the HTML select list [Custom Fields]
          foreach ($params->columns as $column) {
             if ($column->f_type == 8 && $column->custom) {   // Type : RATE
                $name = 'f_'.$column->name;
                $lists->$name = mosHTML::selectList( $vote, 'rating', 'class="inputbox" size="1"', 'value', 'text', 0 );
            }
          }
       }

       if ($params->dynamictitlerevorder) {  // Page Title  in Reversed order ?
         $params->pagetitle = $row->title . " - " . _BMU_business;
       } else {
         $params->pagetitle = _BMU_business . " - " . $row->title;
       }

       $mainframe->SetPageTitle($params->pagetitle);
       $mainframe->appendMetaTag( 'keywords', $row->keywords );

       HTML_jbd::detailbusiness( $row, $option, $lists, $catid, $Itemid, $mode, $search, $access, $params );

    } else {     // Not found or Not authorized...
       echo "<script type='text/javascript'> alert('" ._BMU_SORRY_NO_business. "');</script>\n";
       exit;
    }
}



/**
*  Open business in a Wrapper
*/
function wrapperItem ( $id, $option, $catid=0, $Itemid, $mode, $search, $access, $navstart ) {
    global $database, $my, $mainframe;

    mosjbdTools::LoadjbdParams($params);

    if ($params->allowprivate && $my->usertype != 'Super Administrator') {
       $sqlprivate = 'AND ( (b.private = 0) OR (b.private = 1 AND b.created_by = ' .$my->id. ') )';
    } else {
       $sqlprivate = '';
    }

    if ($params->cancredit && $params->reducerating == -1 && $my->usertype != "Super Administrator") {
       $sqlcredits = 'AND ( (b.credits > 0) OR (b.credits = -1) )';
    } else {
       $sqlcredits = '';
    }

    $database->setQuery( "SELECT b.*"
                    . "\n FROM #__jbd_itemcat as i"
                    . "\n LEFT JOIN #__jbd as b ON b.id = i.itemid"
                    . "\n LEFT JOIN #__jbd_categories as bc ON (bc.id = i.catid OR i.catid = -1)"  // Root Cat = -1
                    . "\n WHERE i.itemid = $id"
                    . "\n AND b.access <= '$my->gid'"
                    . "\n AND (b.published = 1 AND b.approved = 1 AND b.archived = 0)"
                    . "\n AND bc.access <= '$my->gid'"
                    . "\n AND (bc.published = 1 OR bc.id = 0)"
                    . "\n ".$sqlprivate
                    . "\n ".$sqlcredits
    );
    $database->loadObject($row);

    if ($row->id) {  // Valid business


       if ($row->url != "" ) {  // Valid URL

          $params->hitdetail = mosjbdTools::getPref(-1,'params','hitdetail', '0');

          if ( $row->redirect != 1 || ( $row->redirect == 1 && !$params->hitdetail ) ) {  // If the hit is done on detail not when opening url.
             $item = new mosbusiness( $database );
             $item->load($row->id);
             $item->hit($option, $Itemid);
          }

          if ($params->dynamictitlerevorder) {  // Page Title  in Reversed order ?
            $params->pagetitle = $row->title . " - " . _BMU_business;
          } else {
            $params->pagetitle = _BMU_business . " - " . $row->title;
          }

          $mainframe->SetPageTitle($params->pagetitle);
          $mainframe->appendMetaTag( 'keywords', $row->keywords );

          // *** redirect to URL
          HTML_jbd::wrapperbusiness( $row, $option, $lists, $catid, $Itemid, $mode, $search, $access, $navstart, $params );

       } else {  // No URL => back to list...
          listjbd( $option, $catid, $Itemid, $mode, $search, $access, "" );
       }

    } else {     // Not found or Not authorized...
          echo "<script type='text/javascript'> alert('" ._BMU_SORRY_NO_business. "');</script>\n";
          exit;
    }
}



/**
*  Edit business
*/
function editbusinessItem(  $uid, $option, $catid, $Itemid, $mode, $search, $access, $navstart ) {
    global $database, $my, $mosConfig_absolute_path, $mosConfig_live_site, $mainframe;

    mosjbdTools::LoadjbdParams ($params);

    if (!$params->cansubmit && $my->usertype != "Super Administrator") {
       mosNotAuth();
       return;
    }

    $title = trim( mosGetParam( $_REQUEST, 'title', '' ) );
    $url = trim( mosGetParam( $_REQUEST, 'url', '' ) );

    // *** load the row from the db table
    $row = new mosbusiness( $database );
    $row->load( $uid );

     if ($uid) {
       // *** existing record
       if ( !( $access->canEdit || ($access->canEditOwn && $row->created_by == $my->id ) || ( $params->regcaneditown && $row->created_by == $my->id ) ) ) {
             mosNotAuth();
             return;
       }
    } else {
       // *** new record
       if ( !( $access->canEdit || $access->canEditOwn || $params->cansubmit && ( $my->gid >= $params->submitlevel ) ) ) {
             mosNotAuth();
             return;
       }
    }

    $row->loadCustom( $uid );  // Manually retrieve the Custom Fields

    // *** get list of categories
    if ($uid) {
       $database->setQuery( "SELECT catid AS value"
                       . "\n FROM #__jbd_itemcat AS i"
                       . "\n LEFT JOIN #__jbd_categories as bc ON (bc.id = i.catid OR i.catid = -1)"  // Root Cat = -1
                       . "\n WHERE i.itemid = $row->id"
                       . "\n AND bc.access <= '$my->gid'"
       );
       $lookup = $database->loadObjectList();
    } else {
       $catid = intval( mosGetParam( $_REQUEST, 'catid', -1 ) );
       if ($catid > 0) {

          // **** SQL : check first if category is published
          $Query = "SELECT bc.published"
              . "\n FROM #__jbd_categories AS bc"
              . "\n WHERE bc.id=$catid"
          ;
          $database->setQuery( $Query );
          $catpublished = $database->loadResult();

          if (!$catpublished) {
             $catid = -1;  // Root Cat (ID = -1)
          }
       }

       $lookup[]->value = $catid;
    }

    // *** In which Category the users can submit new jbd (in Any Cats or in Only One)
    if ( ( $params->submitcat == 0 ) || ( ( $params->submitcat != 0 ) && ( $access->canEdit ) || ( $access->canEditOwn ) || (strtolower($my->usertype) == 'super administrator') ) ) {
       // *** Build list of categories
       $database->setQuery( "SELECT bc.id, bc.name"
                       . "\n FROM #__jbd_categories AS bc"
                       . "\n WHERE bc.access <= '".$my->gid."'"
                       . "\n ORDER BY bc.name"
       );
       $catdb = $database->loadObjectList();

       foreach ($catdb as $cat) {
           $temps = explode(' / ', $cat->name);
           $libcat = str_repeat('.', ( count($temps) - 1 ) * 3) . $temps[count($temps) -1 ];
           $categories[] = mosHTML::makeOption( $cat->id, htmlspecialchars($libcat, ENT_NOQUOTES));
       }
       $lists->clist = mosHTML::selectList( $categories, 'catids[]', 'class="inputbox" multiple="multiple" size="15"', 'value', 'text', $lookup );
    } else {  // Only One, but check is available...
       // **** SQL : check if category is present, otherwise set default to RootCat = -1 !
       $Query = "SELECT bc.id"
           . "\n FROM #__jbd_categories AS bc"
           . "\n WHERE bc.id=".$params->submitcat
       ;
       $database->setQuery( $Query );
       $catpresent = $database->loadResult();

       if (!$catpresent) {
          $params->submitcat = -1;  // Root Cat (ID = -1)
       }
    }

    // fail if checked out not by 'me'
    if ($row->checked_out && $row->checked_out <> $my->id) {
        mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&search=$search"), _BM_THE_MODULE . htmlspecialchars($row->title, ENT_NOQUOTES) . _BM_EDITED_BY_ADMIN);
    }

    // *** Default Values
    if ($uid) {
        $row->checkout( $my->id );
        if (!$row->created_by) {   // Unknown Submitter => replace with current admin...
           $row->created_by = $my->id;    // Set current user
        }
    } else {
        // initialise new record
        $row->approved = ( ( $params->submitauto && $my->gid >= $params->submitautolevel ) || ( !$params->submitauto && $my->id > 0 ) ) ? 1 : 0;  // On Guest submission set Approved to "No" ($my->id = 0)
        $row->published = ( ($params->submitauto && $my->gid >= $params->submitautolevel) || $my->gid >= 2) ? 1 : 0;
        if ($params->forceprivate && $my->gid == 1) {  // Force to private and Registered User
           $row->private = 1;    // Set as Private
        } else {
           $row->private = 0;    // Set as Public
        }
        $row->redirect = $params->forceredirect;  // Force Redirect to Open Detail Page    // 0:Open URL | 1:Open Detail
        $row->openwin = 1;    // Set OpenWin to NewPage
        $row->title = $title;
        $row->url = $url;
        $row->created_by = $my->id;   // Set current user

        if ($params->submitnewmetatag && $row->url) {                // If the URL is provided, retrieve the Meta tag Description
           $tags = mosjbdTools::get_meta_tags2 ($row->url);
           if ( $tags['description'] ) {
              $row->description = $tags['description'];              // Replace Desc with Tag
           }
        }

    }

    // build the html selection list [Yes/No]
    $yesno[] = mosHTML::makeOption( '1', _BM_YES );
    $yesno[] = mosHTML::makeOption( '0', _BM_NO );

    // build the html select list for Approval
    $lists->applist = mosHTML::RadioList( $yesno, 'approved', 'class="inputbox"', $row->approved, 'value', 'text' );

    // build the html select list for Publishing
    $lists->publist = mosHTML::RadioList( $yesno, 'published', 'class="inputbox"', $row->published, 'value', 'text' );

    // build the html selection list [Redirect]
    $redirect[] = mosHTML::makeOption( '0', _BM_REDIRECT_URL );
    $redirect[] = mosHTML::makeOption( '1', _BM_REDIRECT_DETAIL );

    // build the html select list for Private
    $lists->redirlist = mosHTML::RadioList( $redirect, 'redirect', 'class="inputbox"', $row->redirect, 'value', 'text' );

    // build the html selection list [Private]
    $private[] = mosHTML::makeOption( '0', _BM_IS_PUBLIC );
    $private[] = mosHTML::makeOption( '1', _BM_IS_PRIVATE );

    // build the html select list for Private
    $lists->privlist = mosHTML::RadioList( $private, 'private', 'class="inputbox"', $row->private, 'value', 'text' );

    // build the html selection list [GetMeta]
    $meta[] = mosHTML::makeOption( '0', _BM_GETMETA_NONE );
    $meta[] = mosHTML::makeOption( '1', _BM_GETMETA_REPLACE );
    $meta[] = mosHTML::makeOption( '2', _BM_GETMETA_PREPEND );
    $meta[] = mosHTML::makeOption( '3', _BM_GETMETA_APPEND );

    // build the html select list for GetMeta
    if ( $params->allow_getmeta == 2 && $params->allowdesc && $my->usertype != "Super Administrator" ) {  // Description is empty and forced to add the Description MetaTag
       $getmetadesc = 2;    // => "Replace Description"
    } else {
       $getmetadesc = 0;    // => "Retrieve Nothing"
    }
    $lists->getmetalist = mosHTML::selectList( $meta, 'getmetadesc', 'class="inputbox" size="1"', 'value', 'text', $getmetadesc );

    if ($row->created_by) {   // To query to look for Guest user... Field is empty !
       // build the html select list for users
       $database->setQuery( "SELECT CONCAT(name,' (',username,')') AS text"
                       . "\n FROM #__users"
                       . "\n WHERE id='".$row->created_by."'"
                       . "\n ORDER BY name"
       );
       $row->username = $database->loadResult();
    } else {
       $row->username = '';
    }

    // *** Prepare Custom Fields
    foreach ($row as $name=>$obj) {
       if (substr($name,0,2)=='f_' && $obj->visibleedit) {

          switch ($obj->f_type) {
            case "1" :  // TEXT
                $lists->$name = '<textarea name="' .$name. '" cols="' .$params->descboxwidth. '" rows="' .$params->descboxheight. '">' .$obj->value. '</textarea>';
                break;
            case "2" :  // VARCHAR
            case "6" :  // URL
            case "7" :  // MAIL
            case "9" :  // POPUP
                $lists->$name = '<input class="inputbox" type="text" name="'.$name.'" value="'.$obj->value.'" size="';
                $lists->$name .= ($obj->f_length > 50) ? '50' : $obj->f_length;
                $lists->$name .= '" maxlength="'.$obj->f_length.'" />';
                break;
            case "3" :  // INT
                $lists->$name = '<input class="inputbox" type="text" name="'.$name.'" value="'.$obj->value.'" size="20" maxlength="20"/>';
                break;
            case "4" :  // TINYINT (Boolean)
                if ($obj->value == '') { $obj->value == 0; }
                $lists->$name = mosHTML::RadioList( $yesno, $name, 'class="inputbox"', $obj->value, 'value', 'text' );
                break;
            case "5" :  // DATE
                $lists->$name = '<input class="inputbox" type="text" name="' .$name. '" id="' .$name. '" size="25" maxlength="19" value="' .$obj->value. '" />';
                $lists->$name .= ' <input type="reset" class="button" value="..." onclick="return showCalendar(\'' .$name. '\', \'y-mm-dd\');" />';
                break;
            default :
          }
       }
    }

    // build the html selection list [RatingAdmin]
    $rateadm[] = mosHTML::makeOption( '0', _BM_ADMIN_RATE_STD );
    $rateadm[] = mosHTML::makeOption( '1', _BM_ADMIN_RATE_BRONZE );
    $rateadm[] = mosHTML::makeOption( '2', _BM_ADMIN_RATE_GOLD );

    // build the html select list for RatingAdmin
    $lists->ratingadm = mosHTML::selectList( $rateadm, 'ratingadmin', 'class="inputbox" size="1"', 'value', 'text', $row->ratingadmin );

    // build the html selection list [ValidationMode]
    $validate[] = mosHTML::makeOption( '0', _BM_VALIDATION_AUTOMATIC );
    $validate[] = mosHTML::makeOption( '1', _BM_VALIDATION_MANUAL );

    // Define the current [Validation Mode] value (Automatic or Manual) according to current "validated" value (0:Not Scanned 1:Manual 999:Automatic)
    $row->validationmode = ($row->validated == 1) ? "1" : "0";

    // build the html select list for ValidationMode
    $lists->validlist = mosHTML::selectList( $validate, 'validationmode', 'class="inputbox" size="1"', 'value', 'text', $row->validationmode);

    $params->pagetitle = ($uid) ? _BM_EDIT . " " . _BMU_business . " : " . $row->title : _BM_ADD . " " . _BMU_business;
    $mainframe->SetPageTitle($params->pagetitle);

    HTML_jbd::editbusiness( $row, $option, $lists, $catid, $Itemid, $mode, $search, $access, $navstart, $params );
}


/**
* Saves the record on an edit form submit
*/
function savebusiness( $option, $catid, $Itemid, $mode, $search, $access, $navstart ) {
    global $database, $my, $access, $my, $mosConfig_sitename, $mosConfig_live_site, $mosConfig_fromname, $mosConfig_mailfrom;

    mosjbdTools::LoadjbdParams ($params);

    if (!$params->cansubmit && $my->usertype != "Super Administrator") {
       mosNotAuth();
       return;
    }

    $catids = mosGetParam( $_POST, 'catids', array(0) );

    if (sizeof($catids) == 0 || ( sizeof($catids) == 1 && $catids[0] == 0 ) ) { $catids[0] = -1; }  // default cat => Root Cat = -1

    $row = new mosbusiness( $database );

    // Workaround : for FCKeditor editor that confuse the description field in the Meta tag with the Input field...
    $row->set("descriptions","");         // Add field to list to correctly bind() fields with record
    $row->set("validationmode","");      // Add field to list to correctly bind() fields with record

    // *** Manually Retrieve Posted Custom fields
    foreach ($params->columns as $column) {
       if ($column->custom && $column->f_type != 8 ) {
          $name = 'f_'.$column->name;
          $row->set($name,"");          // add custom field to Table variables to bind() the fields to record
       }
    }

    if (!$row->bind( $_POST )) {
        echo "<script type='text/javascript'> alert('".$row->getError()."');  window.history.go(-1);</script>\n";
        exit;
    }

    if ($row->id) {       // *** Existing record
       if ( !( $access->canEdit || ($access->canEditOwn && $row->created_by == $my->id ) || ( $params->regcaneditown && $row->created_by == $my->id ) ) ) {
             mosNotAuth();
             return;
       }
    } else {               // *** New record
       if ( !( $access->canEdit || $access->canEditOwn || $params->cansubmit && ( $my->gid >= $params->submitlevel ) ) ) {
             mosNotAuth();
             return;
       }
    }

    $row->description = $row->descriptions;  // transfert variable content
    unset($row->descriptions);               // remove the no more needed field to avoid issue with store function

    $isnew = ($row->id == 0);

    if ($isnew) {
       // *** new record
       if ( !( $access->canEdit || $access->canEditOwn || $params->cansubmit && ( $my->gid >= $params->submitlevel ) ) ) {
             mosNotAuth();
             return;
       }
    } else {
       // *** existing record
       if ( !( $access->canEdit || ($access->canEditOwn && $row->created_by == $my->id ) || ( $params->regcaneditown && $row->created_by == $my->id ) ) ) {
             mosNotAuth();
             return;
       }
    }

    // *** Verify fields
    if ( !trim(strip_tags($row->description)) ) { $row->description = ''; }         // Workaround : for TinyMCE editor that always leave "<br />" when the field is "empty" => Force to clear the field if only HTML tags !

    // *** Verify Custom fields
    foreach ($params->columns as $column) {
       if ($column->custom) {
          $name = 'f_'.$column->name;
          if ($column->f_type == 6) {  // URL => check for valid protocol
             mosjbdTools::verifyProtocol($row->$name);
          }
       }
    }

    if ($isnew) {

        // initialise new record not yet defiend variables (not transmitted in POST)...
        if ($my->gid == 0) {  // Allow Registred Users (registered=1) to Approve in front-end - Hidden for Guests
           $row->approved = ( ( $params->submitauto && $my->gid >= $params->submitautolevel ) || ( !$params->submitauto && $my->id > 0 ) ) ? 1 : 0;  // On Guest submission set Approved to "No" ($my->id = 0)
        }
        if ($my->usertype != "Super Administrator") {  // Allow Administrators (special=2) to Publish in front-end  - Hidden for Guests and Registred
           $row->published = ( ($params->submitauto && $my->gid >= $params->submitautolevel) || $my->gid >= 2) ? 1 : 0;
        }
        if ( ( !$my->id || !$params->allowprivate || $params->forceprivate ) && !$my->usertype == "Super Administrator" ) {  // Allow Registered (registered=1) to keep business Private in front-end  - Hidden for Guests
           if ($params->forceprivate && $my->gid == 1) {  // Force to private and Registered User
              $row->private = 1;    // Set as Private
           } else {
              $row->private = 0;    // Set as Public
           }
        }
        if ( !($params->allowdetail || $my->usertype == "Super Administrator") ) {  // Allow to enter details in front-end - Admins will always be able to enter details
           $row->redirect = $params->forceredirect;  // Force Redirect to Open Detail Page    // 0:Open URL | 1:Open Detail
        }
        $row->openwin = 1;    // Set OpenWin to NewPage
        if ($params->defaultimage) {
           $row->imageurl = _BM_ADMIN_SNAPSHOTER_URL . $params->urlkey;
        }
    }

    if ( $isnew && (!$row->published || !$row->approved) ) {  // Warning (admin need to approve submission) if submission is not published or not validated (no msg when auto approved)
         $buffer = "msg1";
    }

    // *** Set Creation/Update Date
    $row->modified = date( "Y-m-d H:i:s" );                                                                          // Set modification date to "now"
    if ( $row->created == "" || date($row->created) > date($row->modified) ) { $row->created = $row->modified; }     // Set creation date for New item
    if ( $row->created_by == "" || $row->created_by == 0 ) { $row->created_by = $my->id; }                           // Set Publisher name

    // *** Check for duplicates
    if (!$row->check()) {
        echo "<script type='text/javascript'> alert('".$row->getError()."'); window.history.go(-1); </script>\n";
        exit;
    }

    // *** Get some current business values : url and validated
    $database->setQuery( "SELECT b.id, b.url, b.validated"
                    . "\n FROM #__jbd as b"
                    . "\n WHERE b.id=".$row->id
    );
    $database->loadObject($temp);

    // *** Set Validation Info
    if ($row->validationmode == 1) {    // Manually Validated
       $row->validated = "1";
       $row->validationdate = $row->modified;                       // Update date to today
       $row->validationstatus = _BM_VALIDATION_MANUALLYVALIDATED;   // Set Status to "Manually Validated"...
    } else {                           // Clear info for Automatic validation
       if ($temp->validated == 1) {       // Switch back to Automatic => Clear
          $row->validated = "0";
          $row->validationdate = "0";
          $row->validationstatus = "";
       } else {                           // Already Automatic => Need to clear info if URL changed ?
          if ( $temp->url && $temp->url != $row->url ) {   // Modified URL => Clear
             $row->validated = "0";
             $row->validationdate = "0";
             $row->validationstatus = "";
          }
       }
    }

    unset($row->validationmode);      // remove the no more needed field to avoid issue with store function

    // *** Save the record !
    if (!$row->store()) {
        echo "<script type='text/javascript'> alert('".$row->getError()."'); window.history.go(-1);</script>\n";
        exit;
    }

    // *** Get MetaTag "Description"
    if ($params->allow_getmeta == 2 && !$params->allowdesc && $my->usertype != "Super Administrator") {
       $getmetadesc = 1;    // Force to retrieve Meta Tag description.
    } else {
       $getmetadesc = intval(mosGetParam( $_POST, 'getmetadesc', '0' ));
    }

    if ($row->url && $getmetadesc ) {        // If URL defined and meta tag [description] requested or forced
       $tags = mosjbdTools::get_meta_tags2 ($row->url);
       if ( $tags['description'] ) {

          switch ($getmetadesc) {
            case "1" : // Replace
                $row->description = $tags['description'];                      // Replace Desc with Tag
                break;
            case "2" : // Prepend
                $row->description = $tags['description'] .'<br />' . $row->description;  // Prepend Tag to Desc
                break;
            case "3" : // Append
                $row->description = $row->description . $tags['description'];  // Append Tag to Desc
                break;
            default :  // Do nothing...
          }

          if ( !$row->store() ) {      // *** Save business again as destination Description tag is found...
             echo "<script type='text/javascript'> alert('".$row->getError()."'); window.history.go(-1);</script>\n";
             exit;
          }
       }
    }

    $cids = implode( ',', $catids );

    // *** Remove no more assigned Categories for this business
    $database->setQuery( "DELETE FROM #__jbd_itemcat WHERE itemid=$row->id AND catid NOT IN ($cids)" );
    if ( !$database->query() ) {
       echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
       exit;
    }

    // *** Add new Categories (not already assigned)
    foreach ($catids as $catid) {

       $cat = false;
       // *** Get current Cat assignation
       $database->setQuery( "SELECT i.*"
                       . "\n FROM #__jbd_itemcat AS i"
                       . "\n WHERE i.itemid=".$row->id." AND i.catid=".$catid
       );
       $database->loadObject($cat);

       if ( !$cat ) {  // *** Assign Category only if item is not found !
          $database->setQuery( "INSERT INTO #__jbd_itemcat (itemid, catid) VALUES ($row->id, $catid)" );
          if ( !$database->query() ) {
             echo "<script type='text/javascript'> alert('".$database->getErrorMsg()."'); window.history.go(-1);</script>\n";
             exit;
          }
          $catitem = new mosbusinessItemCat( $database );
          $catitem->updateOrder( "catid=".$catid );
       }
    }

    $row->checkin();

    // *** Notify Admins & Validate url
    if ( $my->usertype != 'Super Administrator' ) {   //  Submitter is not a superadmin
       if ( $isnew && $params->submitnotify ) {   // Notify if new business

          if (!$my->id) {
             $sender = _BM_NOTIFY_UNREGISTERED;
          } else {
             // *** Get user info (seems that $my does not hold it correctly...)
             $query = "SELECT id, name, email"
                 . "\n FROM #__users"
                 . "\n WHERE id = '$my->id'"
             ;
             $database->setQuery( $query );
             $database->loadObject($user);
             $sender = $user->name;
          }

          // *** Build message
          $subject = sprintf (_BM_NOTIFY_SUBJECT, $mosConfig_sitename, $sender);
          $subject = html_entity_decode($subject, ENT_QUOTES);

          $message = sprintf (_BM_NOTIFY_MSG, $sender, $mosConfig_sitename, $mosConfig_live_site, $row->title, $row->url, $row->description);
          $message = html_entity_decode($message, ENT_QUOTES);

          // *** Get admins list
          $query = "SELECT email, name"
              . "\n FROM #__users"
              . "\n WHERE sendemail = '1'"        // Requested the notification...
              . "\n AND (usertype = 'superadministrator' OR usertype = 'super administrator')"     // Filter to restrict mail sending to only SuperAdmins
          ;
          $database->setQuery( $query );
          if(!$database->query()) {
              echo $database->stderr( true );
              return;
          }
          $adminRows = $database->loadObjectList();

          // *** Send mail to each admin
          foreach( $adminRows as $adminRow) {

              echo '<b>Business Directory : Sending Mail</b><br />'."\n";
              echo '<br />'."\n";
              echo "<b>FROM</b> : $mosConfig_fromname &lt;".$mosConfig_mailfrom."&gt;<br />\n";
              echo "<b>TO</b> : $adminRow->name <b>&lt;".$adminRow->email."&gt;</b><br />\n";
              echo "<b>SUBJECT</b> : ".$subject."<br />\n";
              echo "<b>BODY</b> : <pre />".$message."<pre />\n";
              echo "<br />\n";
              echo '<span class="back_button"><a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$navstart."&mode=".$mode."&search=".$search). '"><b>'. _BACK. '</b></a></span><br />';

              // *** New "Customised" way
              mosMail($mosConfig_mailfrom, $mosConfig_fromname, $adminRow->email, $subject, $message );

          }
       }

       // *** Validate URL
       if ( $params->validatesubmit && $row->published && $row->approved ) {     // Check only if published and validated...
          mosjbdTools::validateURL ($option, $Itemid, $row->id, $params);  // Validate Page
       }

       // *** Notify Front-end for Admin validation
       mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search&msg=$buffer") );

    } else {  // Edited by admins - no notification

       // *** Validate URL
       if ( $params->validatesubmit && $row->published && $row->approved ) {     // Check only if published and validated...
          mosjbdTools::validateURL ($option, $Itemid, $row->id, $params);  // Validate Page
       }

       // *** No Front-End Notification...
       mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search") );

    }
}

/**
* Cancels an edit operation
*/
function cancelbusiness( $option, $catid, $Itemid, $mode, $search, $navstart ) {
    global $database;

    $row = new mosbusiness( $database );
    if (!$row->bind( $_POST )) {
        echo "<script type='text/javascript'> alert('".$row->getError()."');  window.history.go(-1);</script>\n";
        exit;
    }
    $row->checkin();

    mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search") );
}


function recommendItem ( $id, $option, $catid=0, $Itemid, $mode, $search, $access, $navstart, $isdetail=false ) {
   global $database, $my;

   mosjbdTools::LoadjbdParams($params);

   if ( !$my->id || !$params->canrecommend ) {
      mosNotAuth();
      return;
   }

   $params->navstart = intval( mosGetParam( $_REQUEST, 'navstart', 0 ) );  // Navigation : retrieve the page # to display

   if ($params->allowprivate && $my->usertype != 'Super Administrator') {
      $sqlprivate = 'AND ( (b.private = 0) OR (b.private = 1 AND b.created_by = ' .$my->id. ') )';
   } else {
      $sqlprivate = '';
   }
   $database->setQuery( "SELECT b.*, u.name as username"
                   . "\n FROM #__jbd_itemcat as i"
                   . "\n LEFT JOIN #__jbd AS b ON b.id = i.itemid"
                   . "\n LEFT JOIN #__jbd_categories AS bc ON (bc.id = i.catid OR i.catid = -1)"  // Root Cat = -1
                   . "\n LEFT JOIN #__users AS u ON u.id = b.created_by"
                   . "\n WHERE i.itemid = $id"
                   . "\n AND b.access <= '$my->gid'"
                   . "\n AND (b.published = 1 AND b.approved = 1 AND b.archived = 0)"
                   . "\n AND bc.access <= '$my->gid'"
                   . "\n AND (bc.published = 1 OR bc.id = 0)"
                   . "\n ".$sqlprivate
   );
   $database->loadObject($row);

   if ($row->id) {  // Valid business

      $Query = "SELECT bc.name as category"
          . "\n FROM #__jbd_itemcat i"
          . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
          . "\n WHERE i.itemid = ".$row->id." AND i.catid = ".$catid
      ;

      $database->setQuery( $Query );
      $cats = $database->loadResultArray();

      $row->categories = $cats;
      $row->category = ($cats) ? $cats[0] : "";

      $params->returntask = ($isdetail) ? 'detail' : '';

      HTML_jbd::recommendbusiness( $row, $option, $lists, $catid, $Itemid, $mode, $search, $access, $navstart, $params );

   } else {     // Not found or Not authorized...
      echo "<script type='text/javascript'> alert('" ._BMU_SORRY_NO_business. "');</script>\n";
      exit;
   }
}


function sendItem ( $id, $option, $catid=0, $Itemid, $mode, $search, $access, $navstart, $isdetail=false ) {
   global $database, $my, $mosConfig_sitename, $mosConfig_live_site;

   mosjbdTools::LoadjbdParams($params);

   if ( !$my->id || !$params->canrecommend ) {
      mosNotAuth();
      return;
   }

   $params->navstart = intval( mosGetParam( $_REQUEST, 'navstart', 0 ) );  // Navigation : retrieve the page # to display
   $mailaddress = mosGetParam( $_POST, 'mailaddress', "" ) ;       // Retrieve POSTed info
   $mailcomment = mosGetParam( $_POST, 'mailcomment', "" ) ;       // Retrieve POSTed info

   if ($params->allowprivate && $my->usertype != 'Super Administrator') {
      $sqlprivate = 'AND ( (b.private = 0) OR (b.private = 1 AND b.created_by = ' .$my->id. ') )';
   } else {
      $sqlprivate = '';
   }
   $database->setQuery( "SELECT b.*, u.name as username"
                   . "\n FROM #__jbd_itemcat as i"
                   . "\n LEFT JOIN #__jbd AS b ON b.id = i.itemid"
                   . "\n LEFT JOIN #__jbd_categories AS bc ON (bc.id = i.catid OR i.catid = -1)"  // Root Cat = -1
                   . "\n LEFT JOIN #__users AS u ON u.id = b.created_by"
                   . "\n WHERE i.itemid = $id"
                   . "\n AND b.access <= '$my->gid'"
                   . "\n AND (b.published = 1 AND b.approved = 1 AND b.archived = 0)"
                   . "\n AND bc.access <= '$my->gid'"
                   . "\n AND (bc.published = 1 OR bc.id = 0)"
                   . "\n ".$sqlprivate
   );
   $database->loadObject($row);

   if ($row->id) {  // Valid business

      $Query = "SELECT bc.name as category"
          . "\n FROM #__jbd_itemcat i"
          . "\n LEFT OUTER JOIN #__jbd_categories bc ON (i.catid = bc.id)"
          . "\n WHERE i.itemid = ".$row->id." AND i.catid = ".$catid
      ;

      $database->setQuery( $Query );
      $cats = $database->loadResultArray();

      $row->categories = $cats;
      $row->category = $cats[0];

      $database->setQuery( "SELECT id, name, username, email"
                       ."\n FROM #__users"
                       ."\n WHERE id='$my->id'"
      );
      $database->loadObject($user);

	   $subject = sprintf (_BM_SEND_SUBJECT, $mosConfig_sitename, $user->name);
      $subject = html_entity_decode($subject, ENT_QUOTES);

		$message = sprintf (_BM_SEND_MSG, $user->name, $mosConfig_sitename, $mosConfig_live_site, $row->title, $row->url, $mailcomment);
      $message = html_entity_decode($message, ENT_QUOTES);

      echo '<b>Business Directory : Sending Mail</b><br />'."\n";
      echo '<br />'."\n";
      echo "FROM : <b>$user->name &lt;".$user->email."&gt;</b><br />\n";
      echo "TO : <b>&lt;".$mailaddress."&gt;</b><br />\n";
      echo "Subject : <b>".$subject."</b><br />\n";
      echo "Body : <b><br />".$message."</b><br />\n";
      echo "<br />\n";
      echo '<span class="back_button"><a href="' .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&catid=$catid&navstart=".$params->navstart."&mode=".$mode."&search=".$search). '"><b>'. _BACK. '</b></a></span>';

      mosMail($user->email, $user->name, $mailaddress, $subject, $message );

      if ($isdetail) {
         mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=detail&id=".$id."&catid=$catid&mode=".$mode."&navstart=".$navstart."&search=$search&msg=msg2") );
      } else {
         mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&id=".$id."&catid=$catid&mode=$mode&navstart=$navstart&search=$search&msg=msg2") );
      }

   }
}


/**
*  Vote/Rate a business
*/
function voteItem( $id, $option, $catid, $Itemid, $mode, $search, $rating, $access, $navstart, $subtask, $isdetail=false ) {
    global $database, $my;
    global $mosConfig_shownoauth, $Itemid;

    if (!$catid) {
        $catid = 0;
    }

    if ($my->id) {  // Registered User => UserId
         $sqlfilter = "\n AND (bv.userid = $my->id)";
         $host = '';
    } else {        // Guest => Host
         if (phpversion() <= "4.2.1") {
             $host = gethostbyaddr( getenv( "REMOTE_ADDR" ) );
         } else {
             $host = gethostbyaddr( $_SERVER['REMOTE_ADDR'] );
         }
         $sqlfilter = "\n AND (bv.host = '$host')";
    }

    if (!$subtask || $subtask == 'rating') {    // Standard
       $name = "vote";
       $namer = "rating";
    } else {            // Custom Field
       $name = $subtask;
       $namer = $subtask;
    }
    $namedate = $name."date";
    $namecount = $namer."count";

    // check if user (UserID) has voted for this item
    $database->setQuery("SELECT bv.id, bv.itemid, bv.$name, bv.$namedate"
                   . "\n FROM #__jbd_vote AS bv"
                   . "\n WHERE (bv.itemid = $id)"
                   . $sqlfilter
    );
    $database->loadObject($rowcheck);

    if ( $rowcheck && $rowcheck->$name > 0 ) {
         // user has already voted for this item
         echo "<script type='text/javascript'>alert('". _BMU_ALREADY_VOTED ."'); window.location='";
         if ($isdetail) {
            echo sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=detail&id=".$id."&mode=$mode&catid=$catid&navstart=$navstart&search=$search");
         } else {
            echo sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search");
         }
         echo "';</script>\n";
         exit;
    } else {
         // User did not voted for this item
         $date = date( "Y-m-d H:i:s" );  // Time : set to "Now"

         if ($rowcheck) {
           $database->setQuery( "UPDATE #__jbd_vote SET $name='".$rating."', $namedate='$date' WHERE id='".$rowcheck->id."'" );  // Update Vote (record created by Tracking system...)
         } else {
           if ($my->id) {
              $database->setQuery( "INSERT INTO #__jbd_vote (itemid, userid, $name, $namedate) VALUES ($id, '$my->id', $rating, '$date')");
           } else {
              $database->setQuery( "INSERT INTO #__jbd_vote (itemid, host, $name, $namedate) VALUES ($id, '$host', $rating, '$date')");
           }
         }

         if (!$database->query()) {
            echo $database->getQuery();
            echo "<script type='text/javascript'>alert('".$database->getErrorMsg()."'); window.location='" .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&search=$search"). "';</script>\n";
            exit;
         }

         $database->setQuery( "SELECT COUNT(*) AS nb, SUM($name) AS sum, id"
                         . "\n FROM #__jbd_vote"
                         . "\n WHERE itemid=$id && $name > '0'"
                         . "\n GROUP BY itemid"
         );

         $database->loadObject($rowvote);
         if ( $rowvote ) {
              if ($rowvote->nb > 0) {
                  $rating = $rowvote->sum / $rowvote->nb;
              }

              $database->setQuery( "UPDATE #__jbd SET $namer='$rating', $namecount='".$rowvote->nb."' WHERE id=$id");

              if (!$database->query()) {
                   echo "<script type='text/javascript'>alert('".$database->getErrorMsg()."'); window.location='" .sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&search=$search"). "';</script>\n";
                   exit;
              }
         }
    }

    if ($isdetail) {
       mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&task=detail&catid=$catid&navstart=".$navstart."&mode=".$mode."&id=".$id."&search=".$search) );
    } else {
       listjbd( $option, $catid, $Itemid, $mode, $search, $access, "" );
    }
}


function checkjbd($id, $option, $catid, $Itemid, $mode, $search, $access, $navstart ) {
    global $my, $database;

    mosjbdTools::LoadjbdParams($params);

    if (!$params->cansubmit && $my->usertype != "Super Administrator") {
       mosNotAuth();
       return;
    }

    $row = new mosbusiness( $database );
    $row->load( $id );

    if ($row->id) {       // *** Existing record
       if ( !( $access->canEdit || ($access->canEditOwn && $row->created_by == $my->id ) || ( $params->regcaneditown && $row->created_by == $my->id ) ) ) {
             mosNotAuth();
             return;
       }

       mosjbdTools::validateURL ($option, $Itemid, $id, $params, sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search") );  // Validate Page

       if (!$params->validatestatus) {
          mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search") );
       }

    } else {
       mosRedirect( sefRelToAbs("index.php?option=$option&Itemid=$Itemid&mode=$mode&catid=$catid&navstart=$navstart&search=$search") );
    }

}

?>